package gus05.entity.gus.app.action.opendatadir;


import java.io.File;

import javax.swing.Action;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Execute;
import gus05.framework.features.Provide;
import gus05.framework.resources.ActionBuilder;



public class ActionOpenDataDir implements Entity, Provide, Execute {


    public String getName()				{return "gus.app.action.opendatadir";}
    public String getCreationDate()		{return "2008.06.28";}


    public static final String ACTIONID_OPENDATADIR = "openDataDir";
    
    private ActionBuilder actionBuilder;
    private Action openAction;
    
    
    private Service exploreDir;
    private File dataDir;
    
    
    public ActionOpenDataDir() throws Exception
    {
    	exploreDir = Outside.service(this,"gus.file.action.exploredir");
    	dataDir = (File) Outside.resource(this,"dataDir");
    	
    	actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
        openAction = actionBuilder.build(ACTIONID_OPENDATADIR,this);
    }
    
    
    public Object provide() throws Exception
    {return openAction;}


    public void execute() throws Exception
    {exploreDir.give(dataDir);}
}

