package gus05.entity.gus.app.action.openjredir;


import java.io.File;

import javax.swing.Action;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Execute;
import gus05.framework.features.Provide;
import gus05.framework.resources.ActionBuilder;



public class ActionOpenJreDir implements Entity, Provide, Execute {


    public String getName()				{return "gus.app.action.openjredir";}
    public String getCreationDate()		{return "2009.07.02";}


    public static final String ACTIONID_OPENJREDIR = "openJreDir";
    
    private ActionBuilder actionBuilder;
    private Action openAction;
    
    
    private Service exploreDir;
    private File jreDir;
    
    
    public ActionOpenJreDir() throws Exception
    {
    	exploreDir = Outside.service(this,"gus.file.action.exploredir");
    	jreDir = new File(System.getProperty("java.home"));
    	
    	actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
        openAction = actionBuilder.build(ACTIONID_OPENJREDIR,this);
    }
    
    
    public Object provide() throws Exception
    {return openAction;}


    public void execute() throws Exception
    {exploreDir.give(jreDir);}
}

