package gus05.entity.gus.app.find.findfont;


import java.awt.Font;

import gus05.framework.core.Entity;
import gus05.framework.features.Transform;



public class FindFont implements Entity, Transform {


    public String getName()				{return "gus.app.find.findfont";}
    public String getCreationDate()		{return "2007.02.03";}

    
    
    

    public Object transform(Object obj) throws Exception
    {
        if(obj instanceof Font) return obj;
        if(obj instanceof String)return retrieveFontFromString((String)obj);
        
        throw new Exception("Invalid type: "+obj.getClass().getName());
    }
    
    
    
    
    private Font retrieveFontFromString(String text) throws Exception
    {
        text = text.toUpperCase();
        String[] n = text.split(" ");
        
        if(n.length!=3)
            throw new Exception("Invalid syntax: "+text);
        
        String name = n[0];
        int style = findStyle(n[1]);
        int size = Integer.parseInt(n[2]);
        
        return new Font(name,style,size);
    }
    
    
    private int findStyle(String info)
    {
        if(info.toLowerCase().equals("plain")) return 0;
        if(info.toLowerCase().equals("bold")) return 1;
        if(info.toLowerCase().equals("italic")) return 2;
        if(info.toLowerCase().equals("bold|italic")) return 3;
        if(info.toLowerCase().equals("italic|bold")) return 3;
        return Integer.parseInt(info);
    }

}

