package gus05.entity.gus.app.restartapp;


import java.io.File;
import java.io.PrintStream;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Execute;



public class RestartApp implements Entity, Give, Execute {


    public String getName()				{return "gus.app.restartapp";}
    public String getCreationDate()		{return "2009.02.14";}




    private Service launchApp;
	private Service exitApp;
	
	private Map internalMap;
	private Object appObject;
	private String[] args;
	private PrintStream out;
	
	private String argsLine;
	private String appPath;
	private String mainClass;
	
	
	
	
	public RestartApp() throws Exception
    {
		launchApp = Outside.service(this,"gus.java.launcher.launchapp");
		exitApp = Outside.service(this,"app.executeexit");
		
		internalMap = (Map) Outside.resource(this,"app.internalmap");
		appObject = Outside.resource(this,"app.object");
		args = (String[]) Outside.resource(this,"app.args");
		out = (PrintStream) Outside.resource(this,"out");
		
		appPath = findAppPath().getAbsolutePath();
		mainClass = appObject.getClass().getName();
    }
	
	
	

	public void execute() throws Exception
	{
		argsLine = join(args);
		restart();
	}
	
	public void give(Object obj) throws Exception
	{
		argsLine = join((String[])obj);
		restart();
	}
	
	private void restart() throws Exception
	{
		internalMap.remove("app.confirmexit");
		internalMap.put("app.executebeforeexit",new AppSelfStart());
		
		out.println("restarting application ...");
		exitApp.execute();
	}
	
	
	
	
	
	
	private class AppSelfStart implements Execute
	{
		public void execute() throws Exception
		{launchApp.give(new String[]{appPath,mainClass,argsLine});}
	}
	
	
	
	
	
	
	
	private String join(String[] tab)
	{
		if(tab.length==0) return null;
		StringBuffer b = new StringBuffer();
		for(int i=0;i<tab.length;i++) b.append(tab[i]+";");
		b.deleteCharAt(b.length()-1);
		return b.toString();
	}
	
	
	
	private File findAppPath()
	{
		String value = System.getProperty("java.class.path");
        String[] paths = value.split(File.pathSeparator);
        return new File(paths[0]);
	}
} 
