package gus05.entity.gus.app.watchrelease.checkfilename;


import java.io.PrintStream;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Filter;



public class CheckFileName implements Entity, Filter {


    public String getName()				{return "gus.app.watchrelease.checkfilename";}
    public String getCreationDate()		{return "2009.04.26";}



    private PrintStream out;
    private Map prop;
    
    private String appID;
    private String appVer;
    private String appBuild;
    

    public CheckFileName() throws Exception
    {
    	out = (PrintStream) Outside.resource(this,"out");
    	prop = (Map) Outside.resource(this,"app.prop.map");
    	
    	appID = (String) prop.get("app.name");
    	appVer = (String) prop.get("app.version");
    	appBuild = (String) prop.get("app.build");
    }



    public boolean filter(Object obj) throws Exception
    {
    	String fileName1 = (String) obj;
    	String fileName = fileName(fileName1);
    	String[] n = fileName.split("_");
    	
    	String appID_ = n[0];
    	String appVer_ = n[1];
    	String appBuild_ = n[3].replace(".","");
    	
    	if(!appID.equals(appID_))
    	{
    		out.println("Wrong release access information for this application !!! (current app name = "+appID+")");
    		return false;
    	}
    	
    	if(!appVer.equals(appVer_)) return true;
    	if(!appBuild.equals(appBuild_)) return true;
    	
        return false;
    }


    
    private String fileName(String name)
    {
    	if(!name.contains(".")) return name;
        String[] n = name.split("\\.");
        int l = n[n.length-1].length();
        return name.substring(0,name.length()-1-l);
    }
    
}

