package gus05.entity.gus.app.watchrelease.infos;


import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.tools.DefaultSupport;



public class Infos extends DefaultSupport implements Entity, Give, Provide {


    public String getName()				{return "gus.app.watchrelease.infos";}
    public String getCreationDate()		{return "2009.02.15";}



    private Map map;
    private String appName;
    private Map prop;
    
    
    public Infos() throws Exception
    {
    	map = (Map) Outside.resource(this,"defaultdatamap");
    	prop = (Map) Outside.resource(this,"app.prop.map");
    	appName = (String) Outside.resource(this,"app.name");
    }
    
    
    
    public void give(Object obj) throws Exception
    {
    	String info = (String) obj;
    	if(info==null) return;
    	if(map.containsKey(appName) && info.equals(map.get(appName))) return;
    	
    	map.put(appName,info);
    	if(!info.equals(""))
    	infosUpdated();
    }
    
    

    public Object provide() throws Exception
    {
    	if(map.containsKey(appName))
    		return map.get(appName);
    	
    	if(prop.containsKey("app.releaseinfo."+appName))
    		return prop.get("app.releaseinfo."+appName);
    	
    	return null;
    }
    
    
    
    private void infosUpdated()
    {send(this,"infosUpdated()");}
}

