/*
 * Created on 28 avr. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.entity.gus.collection.map.form2;


import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;


public class FormPanelModel implements ActionListener {

    
    private FormJPanel panel;
    private Map comps;
    
    
    private Map map;
	private List keys;
	private Retrieve map_ret;
	private boolean editable = true;
	
	
	

    public FormPanelModel(FormJPanel panel, Map map)
    {
        this.panel = panel;
        comps = new HashMap();
        
        this.map = map;
		keys = new Vector(map.keySet());
		updateLabels();
		
		if(map instanceof Support)
	        ((Support)map).addActionListener(this);
	    if(map instanceof Retrieve)
	        map_ret = (Retrieve)map;
    }
    
    
    
    
    
    private JTextField createComp(String name)
    {
        String value = map.get(name).toString();
        JTextField textField = new JTextFieldRed(value);
        
        textField.addActionListener(this);
        textField.setName(name);
        textField.setEditable(editable);
        return textField;
    }
    
    
    
    
    private void clearComps()
    {
        Iterator it = comps.keySet().iterator();
        while(it.hasNext())
        {
            Object key = it.next();
            JTextField comp = (JTextField)comps.get(key);
            comp.removeActionListener(this);
            it.remove();
        }
    }
    
    
    
    
    
    private void updateLabels()
    {
        clearComps();
        panel.clear();
        
        for(int i=0;i<keys.size();i++)
        {
            String name = (String)keys.get(i);
            JTextField comp = createComp(name);
            
            comps.put(name,comp);
            panel.addLabel(name,comp);
        }
    }
    
    
    
    
    
    
    
    public void actionPerformed(ActionEvent evt)
    {
        if(evt.getSource() instanceof JTextField)
            valueEdited((JTextField)evt.getSource());
        else mapActionPerformed(evt.getActionCommand());
    }
    
    
    
    private void valueEdited(JTextField comp)
    {
        String name = comp.getName();
        String value = comp.getText();
        map.put(name,value);
        comp.setForeground(Color.BLACK);
    }
    
    
    
    private void mapActionPerformed(String command)
    {
        if(command.equals("put(Object,Object)"))	put();
        if(command.equals("remove(Object)"))		removed();
        if(command.equals("clear()"))				cleared();
        if(command.equals("putAll(Map)"))			putAll();
    }
    
    
        
        
        
    private void put()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            if(map.size()>keys.size()) addNewKey(key);
            else updateKey(key);
        }
        catch(Exception e){}
    }
    
    
    
    private void putAll()
    {
        keys = new Vector(map.keySet());
        updateLabels();
    }
    
    
    
    private void removed()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            removeKey(key);
        }
        catch(Exception e){}
    }
    
    
    private void cleared()
    {
        keys.clear();
        clearComps();
        panel.clear();
    }
    
    
    
    
    private void addNewKey(Object key)
    {
        keys.add(key);
        
        String name = (String)key;
        JTextField comp = createComp(name);
        
        comps.put(name,comp);
        panel.addLabel(name,comp);
    }
    
    
    private void removeKey(Object key)
    {
        int index = keys.indexOf(key);
        keys.remove(key);
        comps.remove(key);
        panel.removeLabelAt(index);
    }
    
    
    private void updateKey(Object key)
    {
        JTextField textField = (JTextField)comps.get(key);
        String value = (String)map.get(key);
        textField.setText(value);
    }

    
    
    public void mapChanged()
    {
        keys = new Vector(map.keySet());
        updateLabels();
    }
    
    
    public void setEditable(boolean editable)
    {
        this.editable = editable;
        Iterator it = comps.keySet().iterator();
        while(it.hasNext())
        {
            String key = (String)it.next();
            JTextField textField = (JTextField)comps.get(key);
            textField.setEditable(editable);
        }
    }
    
    
    
    
    
    private class JTextFieldRed extends JTextField implements DocumentListener
    {
        public JTextFieldRed()
        {
            super();
            getDocument().addDocumentListener(this);
        }        
        public JTextFieldRed(String value)
        {
            super(value);
            getDocument().addDocumentListener(this);
        }
        public void insertUpdate(DocumentEvent e) {setForeground(Color.RED);}
        public void removeUpdate(DocumentEvent e) {setForeground(Color.RED);}
        public void changedUpdate(DocumentEvent e) {} 
    }
}
