
package gus05.entity.gus.collection.map.string.guifactory;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.table.AbstractTableModel;



class MapTableModel extends AbstractTableModel implements ActionListener {

	
	private Map map;
	private List keys;
	private Retrieve map_ret;
	
	public Map getMap()
	{return map;}
	
	
	public void setMap(Map map_)
	{
	    if(map!=null)
	    if(map instanceof Support)
	        ((Support)map).removeActionListener(this);
	    
	    map = map_;
	    if(map==null)
	    {
	    	keys = new Vector();
	        fireTableDataChanged();
	        return;
	    }
	    
        if(map_ instanceof Support)
            ((Support)map).addActionListener(this);
        if(map instanceof Retrieve)
	        map_ret = (Retrieve)map;
	    
	    updateTable();
	}
	
	
	
	private void updateTable()
	{
		keys = new Vector(map.keySet());
	    Collections.sort(keys);
	    fireTableDataChanged();
	}
	
	
	
	public int getRowCount()
	{return map!=null?map.size():0;}
	
	public int getColumnCount()
	{return 2;}
	
	
	
	public Object getValueAt(int x, int y)
	{
	    Object key = keys.get(x);
	    if(y==0)return key;
	    else return map.get(key);
	}
	
	
	
	public boolean isCellEditable(int x, int y)
	{return true;}
	
	
	
	
	
	
	// getColumnClass
	
	public Class getColumnClass(int y)
	{
	    if(y==0)return getKeyClass();
	    else return getValueClass();
	}
	
	public Class getKeyClass()
	{
	    try{
	        Class c = (Class)map_ret.retrieve("keyClass");
	        if(c==null)throw new Exception("class null");
	        return c;
	    }
	    catch(Exception e){return String.class;}
	}
	
	public Class getValueClass()
	{
	    try{
	        Class c = (Class)map_ret.retrieve("valueClass");
	        if(c==null)throw new Exception("class null");
	        return c;
	    }
	    catch(Exception e){return Object.class;}
	}
	
	
	
	
	
	// getColumnName
	
	public String getColumnName(int y)
	{
	    if(y==0)return getKeyName();
	    else return getValueName();
	}
	
	public String getKeyName()
	{
	    try
	    {
	        String keyName = (String)map_ret.retrieve("keyName");
	        if(keyName!=null)return keyName;
	    }
	    catch(Exception e){}
	    return "key";
	}
	
	public String getValueName()
	{
	    try
	    {
	        String valueName = (String)map_ret.retrieve("valueName");
	        if(valueName!=null)return valueName;
	    }
	    catch(Exception e){}
	    return "value";
	}
	
	
	
	
	
	
	// set value
	
	public void setValueAt(Object value, int x, int y)
	{
	    if(y==0)modifyKeyAt(x,value);
	    if(y==1)modifyValueAt(x,value);
	}
	
	public void modifyKeyAt(int index, Object newKey)
	{
	    Object key = keys.get(index);
	    Object value = map.get(key);
	    map.remove(key);
	    map.put(newKey,value);
	}
	
	public void modifyValueAt(int index, Object newValue)
	{
	    Object key = keys.get(index);
	    map.put(key,newValue);
	}
	
	public void removeValueAt(int index)
	{
	    Object key = keys.get(index);
	    map.remove(key);
	}
	
	
	
	

    public void actionPerformed(ActionEvent evt)
    {
    	String c = evt.getActionCommand();
    	
        if(c.equals("put(Object,Object)"))put();
        else if(c.equals("remove(Object)"))removed();
        else if(c.equals("clear()"))cleared();
        else if(c.equals("putAll(Map)"))putAll();
        else updateTable();
    }
        
        
        
        
    private void put()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            if(map.size()>keys.size())
                addNewKey(key);
            else updateKey(key);
        }
        catch(Exception e){}
    }
    
    
    
    private void putAll()
    {
        keys = new Vector(map.keySet());
        Collections.sort(keys);
        fireTableDataChanged();
    }
    
    
    
    private void removed()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            removeKey(key);
        }
        catch(Exception e){}
    }
    
    
    
    private void cleared()
    {
        keys.clear();
        fireTableDataChanged();
    }
    
    
    
    
    private void addNewKey(Object key)
    {
        keys.add(key);
        Collections.sort(keys);
        fireTableRowsInserted(keys.size(),keys.size());
    }
    
    
    private void removeKey(Object key)
    {
        int index = keys.indexOf(key);
        keys.remove(key);
        fireTableRowsDeleted(index,index);
    }

    
    private void updateKey(Object key)
    {
        int index = keys.indexOf(key);
        fireTableCellUpdated(index,1);
    }
}
