/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.collection.support;

/**
 * @author gus
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.framework.tools.DefaultSupport;

import java.util.*;




class List1 extends DefaultSupport implements List, Retrieve, Register, Transform, Filter, Give {

	
	private List list;
	
	private String valueName = null;
	private Class valueClass = null;
	
	private Object lastElement;
	private Object lastResult;
	private int lastIndex;
	
	
	
	
	
	public List1(List list)
	{this.list = list;}
	
	public List1()
	{this(new Vector());}

	
	
	
	public List getList()
	{return list;}
	
	public Object getLastElement()
	{return lastElement;}
	
	public Object getLastResult()
	{return lastResult;}
	
	public int getLastIndex()
	{return lastIndex;}
    
    
	
	
	
	public int size()								{return list.size();}
	public boolean isEmpty()						{return list.isEmpty();}
	public int indexOf(Object value)				{return list.indexOf(value);}
	public int lastIndexOf(Object value)			{return list.lastIndexOf(value);}
	public ListIterator listIterator()				{return list.listIterator();}
	public ListIterator listIterator(int index)		{return list.listIterator(index);}
	public List subList(int index1, int index2)		{return list.subList(index1,index2);}
	public Iterator iterator()						{return list.iterator();}
	public Object[] toArray()						{return list.toArray();}
	public Object[] toArray(Object[] array)			{return list.toArray(array);}
	public boolean contains(Object value)			{return list.contains(value);}
	public boolean containsAll(Collection c)		{return list.containsAll(c);}
	public Object get(int index)					{return list.get(index);}
	public String toString()						{return list.toString();}
	public boolean equals(Object o)					{return list.equals(o);}
	
	
	
	public void clear()
	{
		list.clear();
		send(this,"clear()");
	}
	
	
	public boolean add(Object value)
	{
	    lastElement = value;
	    boolean result = list.add(value);
	    if(result) send(this,"add(Object)");
		return result;
	}
	
	
	public void add(int index, Object value)
	{
	    lastIndex = index;
	    lastElement = value;
	    list.add(index,value);
	    send(this,"add(int,Object)");
	}
	
	
	public boolean remove(Object value)
	{
	    lastElement = value;
	    boolean result = list.remove(value);
	    if(result) send(this,"remove(Object)");
		return result;
	}
	
	
	public Object remove(int index)
	{
	    lastIndex = index;
	    lastResult = list.remove(index);
	    send(this,"remove(int)");
		return lastResult;
	}
	
	
	public boolean addAll(Collection c)
	{
	    boolean result = list.addAll(c);
	    if(result) send(this,"addAll(Collection)");
		return result;
	}
	
	
	public boolean addAll(int index, Collection c)
	{
	    lastIndex = index;
	    boolean result = list.addAll(index,c);
	    if(result) send(this,"addAll(int,Collection)");
		return result;
	}
	
	
	public boolean removeAll(Collection c)
	{
	    boolean result = list.removeAll(c);
	    if(result) send(this,"removeAll(Collection)");
		return result;
	}
	
	
	public boolean retainAll(Collection c)
	{
	    boolean result = list.retainAll(c);
	    if(result) send(this,"retainAll(Collection)");
		return result;
	}
	
	
	public Object set(int index, Object value)
	{
	    lastIndex = index;
	    lastElement = value;
	    lastResult = list.set(index,value);
	    send(this,"set(index,Object)");
		return lastResult;
	}
    
    
    private void initList(List list)
    {
        this.list = list;
        send(this,"initList(List)");
    }
    
	
	
	

	
	public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastElement"))return lastElement;
        if(key.equals("lastResult"))return lastResult;
        if(key.equals("lastIndex"))return new Integer(lastIndex);
        if(key.equals("list"))return list;
        
        if(key.equals("valueName"))return valueName;
        if(key.equals("valueClass"))return valueClass;
        
        if(key.equals("keys"))
            return new String[]{"lastElement","lastResult","lastIndex","list","valueName","valueClass"};
        
        throw new Exception("unknown key "+key);
    }


    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("valueName"))		{valueName = (String)obj;return;}
        if(key.equals("valueClass"))	{valueClass = (Class)obj;return;}
        
        throw new Exception("unknown key "+key);
    }

    
    public boolean filter(Object obj) throws Exception 		{return list.contains(obj);}
    public Object transform(Object obj) throws Exception 	{return list.get(((Integer)obj).intValue());}
    public Object provide() throws Exception 				{return list;}
    public void give(Object obj) throws Exception           {initList((List)obj);}
}
