package gus05.entity.gus.env.all.command.mailto;


import java.io.PrintStream;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;



public class CommandMailTo implements Entity, Give {


    public String getName()				{return "gus.env.all.command.mailto";}
    public String getCreationDate()		{return "2009.02.03";}

    
    
    private PrintStream out;
    
    private String os;
    private boolean isWindows;
    private boolean isMac;
    

    public CommandMailTo() throws Exception
    {
    	out = (PrintStream) Outside.resource(this,"out");
    	
    	os = System.getProperty("os.name");
    	isWindows = os.toLowerCase().contains("windows");
    	isMac = os.toLowerCase().contains("mac");
    }


    public void give(Object obj) throws Exception
    {
    	if(isWindows) mailTo_windows((String)obj);
    	else if(isMac) mailTo_mac((String)obj);
    	else throw new Exception("OS not supported: "+os);
    }
    
    
    public void mailTo_windows(String adressMail) throws Exception
    {
    	String command = "rundll32 url.dll,FileProtocolHandler mailto:"+adressMail;
    	Runtime.getRuntime().exec(command);
    	out.println("mailto: "+adressMail+" for windows");
    }
    
    
    public void mailTo_mac(String adressMail) throws Exception
    {
    	String command = "open -a /Applications/Safari.app mailto:"+adressMail;
    	Runtime.getRuntime().exec(command);
    	out.println("mailto: "+adressMail+" for mac");
    }
}

