package gus05.entity.gus.env.config.filesverifier.init;


import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.swing.JOptionPane;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.resources.FileProvider;



public class InitFilesVerifier implements Entity {


    public String getName()				{return "gus.env.config.filesverifier.init";}
    public String getCreationDate()		{return "2009.02.26";}



    private Service installer;
    private Service executeExit;
    private Service askForRestart;
    
    private FileProvider fileProvider;
    
    private Map map;
    private Map map1;
    
    
    

    public InitFilesVerifier() throws Exception
    {
    	installer = Outside.service(this,"gus.env.config.filesverifier.installer");
    	askForRestart = Outside.service(this,"gus.app.restartapp.askforrestart");
    	executeExit = Outside.service(this,"app.executeexit");
    	fileProvider = (FileProvider) Outside.resource(this,"app.files");
    	
    	
    	map = (Map) Outside.resource(this,"defaultdatamap");
    	map1 = new HashMap();
    	
    	initMap1();
    	if(map1.isEmpty()) return;
    	
    	String[] options = new String[]{"Install","Ignore","Exit"};
    	int n = JOptionPane.showOptionDialog(null,installationMessage(),"Installation required",
    			JOptionPane.YES_NO_CANCEL_OPTION,
    			JOptionPane.WARNING_MESSAGE,null,options,options[0]);
    	
    	if(n==2) exit();
    	
    	if(n==0)
    	{
    		install();
    		askForRestart();
    	}
    }


    
    
    
    
    
    private void initMap1() throws Exception
    {
    	Iterator it = map.keySet().iterator();
    	while(it.hasNext())
    	{
    		String key = (String) it.next();
    		if(!key.startsWith("_"))
    		{
    			File file = fileProvider.getFile(key);
        		if(file==null) throw new Exception("Unknown fileID: "+key);
        		
        		if(!file.exists())
        		{
        			String value = (String) map.get(key);
            		map1.put(file,value);
        		}
    		}
    	}
    }
    
    
    
    
    
    
    
    
    
    private void install()
    {
    	try
    	{
    		installer.give(map1);
    		
        	if(checkInstallation())
        	{
        		String message = "Installation complete";
        		JOptionPane.showMessageDialog(null,message,"Success",JOptionPane.PLAIN_MESSAGE);
        	}
        	else
        	{
        		String message = "Some required files are still missing\nInstallation failed";
        		JOptionPane.showMessageDialog(null,message,"Failure",JOptionPane.ERROR_MESSAGE);
        	}
    	}
    	catch(Exception e)
    	{
    		Outside.err(this,"install()",e);
    		String message = "Installation failed:\n"+e;
    		JOptionPane.showMessageDialog(null,message,"Failure",JOptionPane.ERROR_MESSAGE);
    	}
    }
    
    
    
    
    
    
    
    private boolean checkInstallation()
    {
    	Iterator it = map1.keySet().iterator();
    	while(it.hasNext())
    	{
    		File file = (File) it.next();
    		if(!file.exists()) return false;
    	}
    	return true;
    }
    
    
    
    
    
    private String installationMessage()
    {
    	StringBuffer b = new StringBuffer("Required files area missing on your computer\n" +
    			"which may cause this application not to work properly:\n\n");
    	
    	Iterator it = map1.keySet().iterator();
    	while(it.hasNext())
    	{
    		File file = (File) it.next();
    		b.append(" - "+file.getAbsolutePath()+"\n");
    	}
    	return b.toString();
    }
    
    
    
    
    private void exit()
    {
    	try{executeExit.execute();}
    	catch(Exception e)
    	{Outside.err(this,"exit()",e);}
    }
    
    
    private void askForRestart()
    {
    	try{askForRestart.execute();}
    	catch(Exception e)
    	{Outside.err(this,"askForRestart()",e);}
    }
}

