package gus05.entity.gus.env.config.filesverifier.preparefile;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Register;



public class PrepareFile implements Entity, Register {


    public String getName()				{return "gus.env.config.filesverifier.preparefile";}
    public String getCreationDate()		{return "2009.02.26";}


    
    private Service fromPath;
    private Service fromUrl;
    private Service fromInside;
    private Service fromService;
    
    private Object progress;
    


    public PrepareFile() throws Exception
    {
    	fromPath = Outside.service(this,"gus.env.config.filesverifier.preparefile.frompath");
    	fromUrl = Outside.service(this,"gus.env.config.filesverifier.preparefile.fromurl");
    	fromInside = Outside.service(this,"gus.env.config.filesverifier.preparefile.frominside");
    	fromService = Outside.service(this,"gus.env.config.filesverifier.preparefile.fromservice");
    }



    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("progress")) {progress = obj;return;}
        prepareFile(key,(File) obj);
    }
    
    
    
    private void prepareFile(String rule, File file) throws Exception
    {
    	if(file.exists()) return;
    	
    	String[] n = rule.split("#",2);
    	if(n.length!=2) throw new Exception("Invalid rule: "+rule);
    	String type = n[0];
    	String info = n[1];
    	
    	if(type.equals("path")) prepareFromPath(file,info);
    	if(type.equals("url")) prepareFromUrl(file,info);
    	if(type.equals("inside")) prepareFromInside(file,info);
    	if(type.equals("service")) prepareFromService(file,info);
    }
    
    
    
    private void prepareFromPath(File file, String info) throws Exception
    {fromPath.register(info,file);}
    
    private void prepareFromUrl(File file, String info)throws Exception
    {
    	fromUrl.register("progress",progress);
    	fromUrl.register(info,file);
    }
    
    private void prepareFromInside(File file, String info)throws Exception
    {fromInside.register(info,file);}
    
    private void prepareFromService(File file, String info)throws Exception
    {fromService.register(info,file);}
}

