package gus05.entity.gus.env.config.filesverifier.preparefile.frompath;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Register;
import gus05.framework.resources.FileProvider;



public class PrepareFileFromPath implements Entity, Register {


    public String getName()				{return "gus.env.config.filesverifier.preparefile.frompath";}
    public String getCreationDate()		{return "2009.02.26";}


    private Service fileCopy;
    private FileProvider fileProvider;
    

    public PrepareFileFromPath() throws Exception
    {
    	fileCopy = Outside.service(this,"gus.file.treatment.filecopy2");
    	fileProvider = (FileProvider) Outside.resource(this,"app.files");
    }



    public void register(String key, Object obj) throws Exception
    {
        File file = (File) obj;
        if(file.exists()) throw new Exception("File is not missing: "+file);
        prepare(key,file);
    }
    
    
    
    private void prepare(String path, File file) throws Exception
    {
    	File source = fileProvider.getFile(path);
    	if(source==null) throw new Exception("Invalid fileID: "+path);
    	if(!source.exists()) throw new Exception("File not found fileID: "+path+": "+source);
    	
    	fileCopy.give(new File[]{source,file});
    }
}

