package gus05.entity.gus.env.config.filesverifier.preparefile.fromurl;


import java.io.File;
import java.net.URL;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Register;



public class PrepareFileFromUrl implements Entity, Register {


    public String getName()				{return "gus.env.config.filesverifier.preparefile.fromurl";}
    public String getCreationDate()		{return "2009.02.26";}


    private Service downloader;
    private Map prop;
    private Object progress;
    
    

    public PrepareFileFromUrl() throws Exception
    {
    	downloader = Outside.service(this,"gus.web.download.filedownloader.auth1");
    	prop = (Map) Outside.resource(this,"app.prop.map");
    }



    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("progress")) {progress = obj;return;}
        prepare(key,(File) obj);
    }
    
    
    
    private void prepare(String rule, File file) throws Exception
    {
    	if(file.exists()) throw new Exception("File is already prepared: "+file);
        
    	if(rule.contains(";"))
    		downloadFromSecuredURL(rule,file);
    	else downloadFormURL(rule,file);
    }



    private void downloadFormURL(String info, File file) throws Exception
    {
    	String urlStr = prop.containsKey(info)?(String) prop.get(info):info;
    	URL url = new URL(urlStr);
    	
    	downloader.register("file",file);
        downloader.register("url",url);
        downloader.register("login",null);
        downloader.register("password",null);
        downloader.register("progress",progress);
        
        downloader.run();
    }
    
    
    
    private void downloadFromSecuredURL(String info, File file) throws Exception
    {
    	String[] n = info.split(";");
    	if(n.length!=3) throw new Exception("Invalid info: "+info);
    	String urlStr = prop.containsKey(n[0])?(String) prop.get(n[0]):n[0];
    	String login = n[1];
    	String password = n[2];
    	URL url = new URL(urlStr);
    	
    	downloader.register("file",file);
        downloader.register("url",url);
        downloader.register("login",login);
        downloader.register("password",password);
        downloader.register("progress",progress);
        
        downloader.run();
    }
}

