package gus05.entity.gus.file.access.string.csvtab;


import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;

import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Transform;



public class FileAccessStringCsvTab implements Entity, Transform {


    public String getName()				{return "gus.file.access.string.csvtab";}
    public String getCreationDate()		{return "2009.02.04";}

    
    
    private CvsTabParser parser;
    
    public FileAccessStringCsvTab()
    {
    	parser = new CvsTabParser();
    }
    
    
    
    
    public Object transform(Object obj) throws Exception
    {return new FileHolder((File)obj);}

    
    
    private class FileHolder implements Give, Provide
    {
        private File file;
        FileHolder(File file)
        {this.file = file;}
        
        public void give(Object obj) throws Exception
        {write(file,(String[][])obj);}
        
        public Object provide() throws Exception
        {return read(file);}
    }

    
    
    
    
    private void write(File file, String[][] tab) throws Exception
    {
    	PrintStream out = new PrintStream(file);
    	
    	int x = tab.length;
        if(x==0)return;
        int y = tab[0].length;
        if(y==0)return;
        
    	for(int i=0;i<x;i++)
        for(int j=0;j<y;j++)
        {
        	String value = formatValue(tab[i][j]);
        	if(j==y-1)out.println(value);
        	else out.print(value+CvsTabParser.STRING_DELIM);
        }
    	out.close();
    }
    
    
    public String formatValue(String value)
    {
    	if(value==null) return "";
        if(value.contains("\"") || value.contains("\n") || value.contains(CvsTabParser.STRING_DELIM))
        {
            value = value.replace("\"","\"\"");
            return "\""+value+"\"";
        }
        return value;
    }
    
    
    
    
    
    
    
    private String[][] read(File file) throws Exception
    {
        String text = readTextFile(file);
        return parser.parse(text);
    }


    
    
    private String readTextFile(File f) throws Exception
    {
        FileReader fr = new FileReader(f);   
        char[] a = new char[(int)f.length()];
        fr.read(a,0,(int)f.length());
        fr.close();
        return new String(a);
    }
}

