/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.file.editor.gif.editor1;


import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;

import java.io.File;
import java.io.FileFilter;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;




/**
* @author gus
*/
public class GifEditor1 extends DefaultSupport implements Entity, Graphic, Give, Register
{

    public String getName()				{return "gus.file.editor.gif.editor1";}
    public String getCreationDate()		{return "2006.07.15";}
    
    
    

    private JPanelViewIcon panel;
    private File file;
    private String ext;
    private File dir;
    
    private File[] files;
    private Icon[] icons;

    

    public GifEditor1()
    {panel = new JPanelViewIcon();}


    public JComponent gui()
    {return panel;}
    
    
    
    
    
    private boolean directoryChanged(File dir_)
    {return dir==null || !dir.equals(dir_);}
    
    private boolean extensionChanged(String ext_)
    {return ext==null || !ext.equals(ext_);}


    
    

    public void give(Object obj) throws Exception
    {
        file = (File)obj;
        
        String ext_ = extension(file);
        File dir_ = file.getParentFile();
        
        if(directoryChanged(dir_) || extensionChanged(ext_))
        {
            dir = dir_;
            ext = ext_;
            rebuildPanel();
        }
        int index = findFileIndex();
        panel.select(index);
    }
    

    
    
    private void rebuildPanel()
    {
        files = dir.listFiles(new FileFilter(){
            public boolean accept(File f)
            {return extension(f).equals(ext);}
        });
        icons = new Icon[files.length];
        for(int i=0;i<files.length;i++)
        icons[i] = new ImageIcon(files[i].getAbsolutePath());
        
        panel.init(icons);
    }
    
    
    
    
    private String extension(File file)
    {
        String[] n = file.getName().split("\\.");
        if(n.length>1) return n[n.length-1].toLowerCase();
        return "";
    }
    
    
    
    private int findFileIndex()
    {
        for(int i=0;i<files.length;i++)
        if(files[i].equals(file)) return i;
        return -1;
    }
    
    
    
    
    public void register(String key, Object obj) throws Exception {
    }
    
}
