/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.file.editor.html.editor1;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JComponent;
import javax.swing.JTextPane;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;


/**
* @author gus
*/
public class HtmlEditor1 extends DefaultSupport implements Entity, Graphic, Give, Register
{

    public String getName()				{return "gus.file.editor.html.editor1";}
    public String getCreationDate()		{return "2006.07.15";}
    

    
    private JTextPane textPane;
    
    public HtmlEditor1()
    {
        textPane = new JTextPane();
        textPane.setEditable(false);
        textPane.setContentType("text/html");
    }


    
    public void displayURL(URL url)
    {
        try
        {     
        	textPane.setContentType("text/plain");
        	textPane.setText("");
            
            if(url!=null)
            {
                textPane.setContentType("text/html");
                textPane.setPage(url);
            }
        }
        catch(IOException e)
        {Outside.err(this,"displayURL(URL)",e);}
    }



    public JComponent gui()
    {return textPane;}



    public void give(Object obj) throws Exception
    {
        URL url = toURL(obj);
        displayURL(url);
    }
    
    
    private URL toURL(Object obj) throws MalformedURLException
    {
        if(obj==null) return null;
        if(obj instanceof URL) return (URL)obj;
        if(obj instanceof File) return ((File)obj).toURI().toURL();
        return new URL(obj.toString());
    }
    
    
    
    public void register(String key, Object obj) throws Exception {
    }
}
