package gus05.entity.gus.file.editor.prop.editor4;


import java.awt.event.ActionListener;
import java.util.List;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.features.Support;

import javax.swing.JComponent;
import javax.swing.JTabbedPane;



public class PropEditor4 implements Entity, Support, Give, Graphic, Register {


    public String getName()				{return "gus.file.editor.prop.editor4";}
    public String getCreationDate()		{return "2008.06.08";}



    private Service mapEditor1;
    private Service mapEditor2;
    private Service mapEditor3;
    private Service fileHolder;
    
    private JTabbedPane tab;
    private Map map;
    
    
    
    public PropEditor4() throws Exception
    {
    	fileHolder = Outside.service(this,"gus.file.holder.properties");
        mapEditor1 = Outside.service(this,"mapEditor1");
        mapEditor2 = Outside.service(this,"mapEditor2");
        mapEditor3 = Outside.service(this,"mapEditor3");
        
        tab = new JTabbedPane();
        tab.addTab("editor1",mapEditor1.gui());
        tab.addTab("editor2",mapEditor2.gui());
        tab.addTab("editor3",mapEditor3.gui());
    }
    


    public void give(Object obj) throws Exception
    {
    	fileHolder.give(obj);
    	map = (Map) fileHolder.provide();

    	mapEditor1.give(map);
    	mapEditor2.give(map);
    	mapEditor3.give(map);
    }
    
    
    

    public JComponent gui()
    {return tab;}

    
    
    
    public void register(String key, Object obj) throws Exception
    {fileHolder.register(key,obj);}

    
	public void addActionListener(ActionListener listener) {fileHolder.addActionListener(listener);}
	public void removeActionListener(ActionListener listener) {fileHolder.removeActionListener(listener);}
	public List listeners() {return fileHolder.listeners();}
}

