
package gus05.entity.gus.file.editor.rtf.editor1;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.text.rtf.RTFEditorKit;



/**
* @author gus
*/
public class RtfEditor1 extends DefaultSupport implements Entity, Graphic, Give, Register
{

    public String getName()				{return "gus.file.editor.rtf.editor1";}
    public String getCreationDate()		{return "2006.07.14";}


    
    private RTFEditorKit rtf;
    private JEditorPane editorPane;
    private File file;

    

    public RtfEditor1()
    {
        rtf = new RTFEditorKit();
        editorPane = new JEditorPane();
        editorPane.setEditorKit(rtf);
        editorPane.setEditable(false);
    }






    public JComponent gui()
    {return editorPane;}

    


    public void give(Object obj) throws Exception
    {
        editorPane.setText("");
        file = (File)obj;
        if(file==null)return;
        
        FileInputStream fis = new FileInputStream(file);
        rtf.read(fis,editorPane.getDocument(),0);
		fis.close();
		editorPane.setCaretPosition(0);
    }
    
    
    
    private void saveFile()
    {
        try
        {
            FileOutputStream fos = new FileOutputStream(file);
            int length = editorPane.getDocument().getLength();
            rtf.write(fos,editorPane.getDocument(),0,length);
            fos.close();
        }
        catch(Exception e)
        {Outside.err(this,"saveFile()",e);}
    }
    
    


    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("save"))
        {
            saveFile();
            return;
        }
        throw new Exception("Unknown key: "+key);
    }
}
