
package gus05.entity.gus.file.explorer.explorer1;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.Scrollable;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;


public class Explorer1 implements Entity, Graphic, Give, Provide, Retrieve, Execute, Support {

    public String getName()				{return "gus.file.explorer.explorer1";}
    public String getCreationDate()		{return "2006.07.13";}
    

    private Service explorer;
    private Service rootControl;
    
    private JPanel pane;
    private JTree tree;
    
    
    
    public Explorer1() throws Exception
    {
        explorer = Outside.service(this,"gus.file.explorer.tree1");
        rootControl = Outside.service(this,"gus.file.explorer.control.rootcontrol1");
        
        tree = (JTree) explorer.retrieve("tree");
        rootControl.register("rootReceiver",explorer);
        rootControl.register("tree",tree);
        
        JComponent explorerComp = explorer.gui();
        if(explorerComp instanceof Scrollable)
            explorerComp = new JScrollPane(explorerComp);
        
        pane = new JPanel(new BorderLayout());
    	pane.add(rootControl.gui(),BorderLayout.NORTH);
    	pane.add(explorerComp,BorderLayout.CENTER);
    }
    
    
    
    public JComponent gui()
    {return pane;}
    
    
    public void give(Object obj) throws Exception
    {rootControl.give(obj);}

    
    public Object provide() throws Exception
    {return rootControl.provide();}
    
    
    public void execute() throws Exception
    {rootControl.execute();}
    
    
    
    
    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("selectedFile")) return explorer.provide();
        throw new Exception("Unknown key: "+key);
    }
    
    
    public void addActionListener(ActionListener listener) {explorer.addActionListener(listener);}
    public void removeActionListener(ActionListener listener) {explorer.removeActionListener(listener);}
    public List listeners() {return explorer.listeners();}
	
}
