package gus05.entity.gus.file.holder.properties;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Support;
import gus05.framework.tools.DefaultSupport;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Map;
import java.util.Properties;



public class HolderProperties extends DefaultSupport implements Entity, Give, Provide, Register, ActionListener {


    public String getName()				{return "gus.file.holder.properties";}
    public String getCreationDate()		{return "2008.06.08";}


    private Service collectionSupport;
    
    private File file;
    private Properties prop;
    private Support map_sup;
    private Map map;
    
    

    public HolderProperties() throws Exception
    {
    	collectionSupport = Outside.service(this,"gus.collection.support");
    }



    public void give(Object obj) throws Exception
    {
    	file = (File)obj;
    	if(file==null)
    	{map = null;return;}
    	
    	loadFile();
    	
    	if(map_sup!=null)
    		map_sup.removeActionListener(this);
    	map = (Map)collectionSupport.transform(prop);
    	map_sup = (Support)map;
    	map_sup.addActionListener(this);
    }



    public Object provide() throws Exception
    {return map;}
    
    
    
    public void actionPerformed(ActionEvent e)
    {dataModified();}
    
    
    private void dataModified()
    {send(this,"dataModified()");}
    
    



    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("save"))
        {saveFile();return;}
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    
    private void saveFile()
    {
        try
        {
        	FileOutputStream fos = new FileOutputStream(file);
        	prop.store(fos,"");
        	fos.close();
        }
        catch(Exception e)
        {Outside.err(this,"saveFile()",e);}
    }
    
    
    
    private void loadFile()
    {
        try
        {
        	prop = new Properties();
        	FileInputStream fis = new FileInputStream(file);
        	prop.load(fis);
        	fis.close();
        }
        catch(Exception e)
        {Outside.err(this,"loadFile()",e);}
    }

}

