package gus05.entity.gus.file.label.filelabel;

import java.io.File;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.tools.DefaultSupport;


public class FileLabel extends DefaultSupport implements Entity, Give, Provide, Graphic {

    public String getName()				{return "gus.file.label.filelabel";}
    public String getCreationDate()		{return "2006.07.13";}
    
    
    private Service dnd;
    private Service fileIcon;
    
    private JLabel label;
    private File file;
    
    
    private Icon icon(File file) throws Exception
    {return (Icon)fileIcon.transform(file);}

    
    
    public FileLabel() throws Exception
    {
        fileIcon = Outside.service(this,"gus.icondisplay.file1");
        label = new JLabel("<>");
        initDnd();
    }
    
    
    private void initDnd()
    {
        try
        {
            dnd = Outside.service(this,"gus.graphic.dnd");
            dnd.register("give",this);
            dnd.register("provide",this);
            dnd.register("comp",label);
        }
        catch(Exception e)
        {Outside.err(this,"initDnd()",e);}
    }
    
    
    
    
    public void give(Object obj) throws Exception
    {
        if(obj==null)
        {initialize();return;}
        
        if(obj instanceof File) file = (File)obj;
        else file = new File(obj.toString());
        
        if(file.isDirectory())
        {file=null;return;}
        
        handleFile();
    }

    
    public Object provide() throws Exception
    {return file;}
    
    
    public JComponent gui()
    {return label;}
    
    
    
    
    
    private void handleFile()
    {
        try
        {
        	String path = file.getAbsolutePath();
            String name = file.getName();
            if(name.equals("")) name = path;
            
            label.setToolTipText(path);
            
            if(!file.exists())
            {
                label.setText("<"+name+">");
                label.setIcon(null);
                return;
            }
            
            label.setText(name);
            label.setIcon(icon(file));
            
            fileChanged();
        }
        catch(Exception e)
        {Outside.err(this,"handleFile()",e);}
    }
    
    
    
    private void initialize()
    {
    	file = null;
    	label.setText(" ");
    	label.setToolTipText(null);
        label.setIcon(null);
        
        fileChanged();
    }

    
    
    
    private void fileChanged()
    {send(this,"fileChanged()");}
}
