/*
 * Created on 13 juil. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.entity.gus.file.label.load.filedirlabel2;

import java.awt.BorderLayout;
import java.io.File;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToolBar;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.tools.DefaultSupport;


public class FileDirLabel2 extends DefaultSupport implements Entity, Give, Provide, Graphic {

    public String getName()				{return "gus.file.label.load.filedirlabel2";}
    public String getCreationDate()		{return "2007.08.05";}
    
    
    private Service dnd;
    private Service fileIcon;
    private Service toolbar;
    private Service chooseRoot;
    private Service loadDir;
    
    private JLabel label;
    private JPanel pane;
    private File file;
    

    
    
    public FileDirLabel2() throws Exception
    {
        fileIcon = Outside.service(this,"gus.icondisplay.file1");
        toolbar = Outside.service(this,"gus.graphic.toolbar.toolbar1");
        chooseRoot = Outside.service(this,"gus.file.label.chooseroot");
        loadDir = Outside.service(this,"gus.file.action.load.filedir");
        
        JComponent comp1 = (JComponent)chooseRoot.transform(this);
        Action loadDirAction = (Action)loadDir.transform(this);
        
        JToolBar toolBar = (JToolBar)toolbar.gui();
        
        toolBar.add(comp1);
        toolBar.add(loadDirAction);
        toolBar.addSeparator();
        
        label = new JLabel("<>");
        
        pane = new JPanel(new BorderLayout());
        pane.add(toolBar,BorderLayout.WEST);
        pane.add(label,BorderLayout.CENTER);
        initDnd();
    }
    
    
    private void initDnd()
    {
        try
        {
            dnd = Outside.service(this,"gus.graphic.dnd");
            dnd.register("give",this);
            dnd.register("provide",this);
            dnd.register("comp",label);
        }
        catch(Exception e)
        {Outside.err(this,"initDnd()",e);}
    }
    
    
    
    
    public void give(Object obj) throws Exception
    {
        if(obj==null)return;
        
        if(obj instanceof File) file = (File)obj;
        else file = new File(obj.toString());
        
        handleFile();
    }

    
    public Object provide() throws Exception
    {return file;}
    
    
    public JComponent gui()
    {return pane;}
    
    
    
    
    
    private void handleFile()
    {
        try
        {
        	String path = file.getAbsolutePath();
            String name = file.getName();
            if(name.equals("")) name = path;
            
            label.setToolTipText(path);
            
            if(!file.exists())
            {
                label.setText("<"+name+">");
                label.setIcon(null);
                return;
            }
            
            label.setText(name);
            Icon icon = (Icon)fileIcon.transform(file);
            if(icon!=null)label.setIcon(icon);
            
            send(this,"handleFile()");
        }
        catch(Exception e)
        {Outside.err(this,"handleFile()",e);}
    }

}
