package gus05.entity.gus.file.treatment.filecopy.batchdos.multi;


import java.io.File;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.swing.JOptionPane;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;



public class FileCopyBatchDosMulti implements Entity, Give {


    public String getName()				{return "gus.file.treatment.filecopy.batchdos.multi";}
    public String getCreationDate()		{return "2009.05.05";}

    
    public static final long LAPSE = 20000;


    private File tempDir;
    private File batchFile;

    
    public FileCopyBatchDosMulti() throws Exception
    {
    	tempDir = (File) Outside.resource(this,"defaultdir");
    	batchFile = new File(tempDir,"copyFiles.bat");
    }



    public void give(Object obj) throws Exception
    {
    	Map map = (Map) obj;
    	PrintStream p = new PrintStream(batchFile);
    	println(p,map);
    	p.close();
    	
    	executeFile(batchFile);
    	
    	Map map1 = buildFailedMap(map);
    	if(map1.isEmpty()) return;
    	
    	PrintStream p1 = new PrintStream(batchFile);
    	println(p1,map1);
    	p.close();
    	
    	String message = "Some file copy could not be performed by the Java application\n" +
    			"because of security restrictions.\n\n" +
    			"To perform the file copy, please execute in administrator mode\n" +
    			"the DOS batch file "+batchFile.getName()+" which is about to be displayed";
    	String title = "Security restrictions";
    	
    	JOptionPane.showMessageDialog(null,message,title,JOptionPane.OK_OPTION);
    	
    	exploreDir(tempDir);
    	
    	long t1 = time();
    	while(!checkAllExistsMap(map1))
    	{
    		Thread.yield();
    		if(time()-t1>LAPSE)
    		{
    			JOptionPane.showMessageDialog(null,"Click OK to continue");
    			return;
    		}	
    	}
    }
    
    
    
    
    
    private void println(PrintStream p, Map map)
    {
    	Iterator it = map.keySet().iterator();
    	while(it.hasNext())
    	{
    		File in = (File) it.next();
        	File out = (File) map.get(in);
        	if(in.exists())
        	p.println("copy "+path(in)+" "+path(out.getParentFile()));
    	}
    }
    
    
    
    private Map buildFailedMap(Map map)
    {
    	HashMap map1 = new HashMap();
    	Iterator it = map.keySet().iterator();
    	while(it.hasNext())
    	{
    		File in = (File) it.next();
        	File out = (File) map.get(in);
        	if(!out.exists()) map1.put(in,out);
    	}
    	return map1;
    }
    
    
    
    private boolean checkAllExistsMap(Map map)
    {
    	Iterator it = map.keySet().iterator();
    	while(it.hasNext())
    	{
    		File in = (File) it.next();
        	File out = (File) map.get(in);
        	if(!out.exists()) return false;
    	}
    	return true;
    }
    
    
    private long time()
    {return System.currentTimeMillis();}
    
    
    
    
    
    
    private void exploreDir(File dir) throws Exception
    {
    	String command = "explorer "+path(dir);
    	Runtime.getRuntime().exec(command);
    }
    
    private void executeFile(File file) throws Exception
    {
    	String command = "cmd "+path(file);
    	Runtime.getRuntime().exec(command);
    }
    
    
    private String path(File f)
    {return "\""+f.getAbsolutePath()+"\"";}
}

