package gus05.entity.gus.file.treatment.filecopy2;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class FileCopy2 implements Entity, Give {


    public String getName()				{return "gus.file.treatment.filecopy2";}
    public String getCreationDate()		{return "2009.02.26";}



    private Service batchDos;

    public FileCopy2() throws Exception
    {
    	batchDos = Outside.service(this,"gus.file.treatment.filecopy.batchdos");
    }



    public void give(Object obj) throws Exception
    {
    	File[] f = (File[]) obj;
    	
    	try{COPY(f[0],f[1]);}
    	catch(FileNotFoundException e)
    	{
    		if(isWindows()) batchDos.give(f);
    		else throw e;
    	}
    }
    


    
    private void COPY(File in, File out) throws IOException
    {
    	if(!in.exists()) return;
        out.getParentFile().mkdirs();
        
        FileInputStream fis = new FileInputStream(in);
        FileOutputStream fos = new FileOutputStream(out);
        
        FileChannel inputChannel = fis.getChannel();
        FileChannel outputChannel = fos.getChannel();
        
        outputChannel.transferFrom(inputChannel,0,in.length());
        
        fis.close();
        fos.close();
    }
    
    
    
    private boolean isWindows()
    {return System.getProperty("os.name").toLowerCase().contains("windows");}
}

