package gus05.entity.gus.file.treatment.filecopy2.multi;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.Iterator;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class FileCopy2Multi implements Entity, Give {


    public String getName()				{return "gus.file.treatment.filecopy2.multi";}
    public String getCreationDate()		{return "2009.05.05";}



    private Service batchDos;

    public FileCopy2Multi() throws Exception
    {
    	batchDos = Outside.service(this,"gus.file.treatment.filecopy.batchdos.multi");
    }



    public void give(Object obj) throws Exception
    {
    	Map map = (Map) obj;
    	
    	try
    	{
    		Iterator it = map.keySet().iterator();
        	while(it.hasNext())
        	{
        		File in = (File) it.next();
            	File out = (File) map.get(in);
            	COPY(in,out);
        	}
    	}
    	catch(FileNotFoundException e)
    	{
    		if(isWindows()) batchDos.give(map);
    		else throw e;
    	}
    }
    


    
    private void COPY(File in, File out) throws IOException
    {
    	if(!in.exists()) return;
        out.getParentFile().mkdirs();
        
        FileInputStream fis = new FileInputStream(in);
        FileOutputStream fos = new FileOutputStream(out);
        
        FileChannel inputChannel = fis.getChannel();
        FileChannel outputChannel = fos.getChannel();
        
        outputChannel.transferFrom(inputChannel,0,in.length());
        
        fis.close();
        fos.close();
    }
    
    
    
    private boolean isWindows()
    {return System.getProperty("os.name").toLowerCase().contains("windows");}
}

