package gus05.entity.gus.graphic.dialog.popup0;


import java.awt.Dimension;

import javax.swing.JComponent;
import javax.swing.JFrame;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;



public class DialogPopup0 extends DefaultSupport implements Entity, Give, Register, Filter {


    public String getName()				{return "gus.graphic.dialog.popup0";}
    public String getCreationDate()		{return "2009.02.01";}

    
    
    private JFrame mainFrame;
    private Dialog0 dialog;
    
    private int width = 400;
    private int height = -1;
    
    

    public DialogPopup0() throws Exception
    {
    	mainFrame = (JFrame) Outside.resource(this,"app.gui.frame");
        dialog = new Dialog0(mainFrame,this);
    }
    
    
    public void register(String key, Object obj) throws Exception
    {
		if(key.equals("width"))
		{width = obj==null?-1:Integer.parseInt((String)obj);return;}
		if(key.equals("height"))
		{height = obj==null?-1:Integer.parseInt((String)obj);return;}
		if(key.equals("dimension"))
		{
			Dimension d = (Dimension) obj;
			width = d.width;
			height = d.height;
			return;
		}
	}

    
    
    
    public void give(Object obj) throws Exception
	{
    	if(obj==null)
    	{dialog.hideContent();return;}
    	
		JComponent content = (JComponent) obj;
		dialog.showContent(content, width, height);
	}
	
    

	public boolean filter(Object obj) throws Exception
	{return dialog.isVisible();}
}

