
package gus05.entity.gus.graphic.dnd;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.TransferHandler;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;


public class Dnd implements Entity, Register, Graphic {

    public String getName()				{return "gus.graphic.dnd";}
    public String getCreationDate()		{return "2006.07.07";}

    
    private Service flavorProvider;
    private DataFlavor flavor;
    
    private Give give = null;
    private Provide provide = null;
    
    
    
    public Dnd() throws Exception
    {
        flavorProvider = Outside.service(this,"gus.graphic.dnd.flavor");
        flavor = (DataFlavor) flavorProvider.provide();
    }
    
    
    
    
    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("give"))
        {give = (Give)obj;return;}
        
        if(key.equals("provide"))
        {provide = (Provide)obj;return;}
        
        if(key.equals("comp"))
        {
        	if(obj==null) throw new Exception("Invalid null comp");
        	initTransfert((JComponent)obj);
        	return;
        }
        
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    private void initTransfert(JComponent source)
    {new TransferHandler0(give,provide,source,flavor);}

    
    
    
    public JComponent gui()
    {
        JLabel label = new JLabel(" ");
        initTransfert(label);
        return label;
    }
    
    
    
    
    
    
    
    private class TransferHandler0 extends TransferHandler implements MouseListener
    {
        private Give give;
        private Provide provide;
        private DataFlavor flavor;
        
        public TransferHandler0(Give give, Provide provide, JComponent source, DataFlavor flavor)
        {
            super();
            this.give = give;
            this.provide = provide;
            this.flavor = flavor;
            
            source.setTransferHandler(this);
            source.addMouseListener(this);
        }
        
        
        
        protected Transferable createTransferable(JComponent c)
        {
            try
            {
            	if(provide==null) return null;
                Object data = provide.provide();
                return new ObjectTransferable(data,flavor);
            }
            catch(Exception e)
            {Outside.err(Dnd.this,"createTransferable(JComponent)",e);} 
            return null; 
        }
        
        
        public int getSourceActions(JComponent c)
        {return COPY_OR_MOVE;}
        
        
        public boolean importData(JComponent c, Transferable t)
        {
            try
            {
                if(give==null)return false;
                Object data = t.getTransferData(flavor);
                give.give(data);
                return true;
            }
            catch(Exception e)
            {Outside.err(Dnd.this,"importData(JComponent,Transferable)",e);} 
            return false;
        }
        
        
        public boolean canImport(JComponent c, DataFlavor[] flavors)
        {return give!=null;}
        
        
        
        
        
        
        public void mousePressed(MouseEvent e)
        {
            JComponent source = (JComponent)e.getSource();
            exportAsDrag(source,e,COPY);
        }
        
        public void mouseClicked(MouseEvent e){}
        public void mouseReleased(MouseEvent e){}
        public void mouseEntered(MouseEvent e){}
        public void mouseExited(MouseEvent e){}
    }
}
