package gus05.entity.gus.graphic.label.building.weblabel;


import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.JComponent;
import javax.swing.JLabel;



public class BuildingWebLabel implements Entity, Graphic {


    public String getName()				{return "gus.graphic.label.building.weblabel";}
    public String getCreationDate()		{return "2008.12.07";}



    
    private Service url_windows;
    private Service url_mac;
    private Service lingTooltip;
    
    private boolean isWindows;
    private boolean isMac;
    

    public BuildingWebLabel() throws Exception
    {
    	url_windows = Outside.service(this,"gus.env.windows.command.webbrowser");
    	url_mac = Outside.service(this,"gus.env.mac.command.webbrowser");
    	lingTooltip = Outside.service(this,"gus.ling.support.tooltip");
    	
    	String os = System.getProperty("os.name");
    	isWindows = os.toLowerCase().contains("windows");
    	isMac = os.toLowerCase().contains("mac");
    }



    public JComponent gui()
    {
    	if(isWindows) return new JLinkLabel_windows();
    	if(isMac) return new JLinkLabel_mac();
    	return new JLabel();
    }


    
    
    private void showURL_windows(String url)
    {
    	try
    	{
    		if(isWindows) url_windows.give(url);
    	}
    	catch(Exception e)
    	{Outside.err(this,"showURL_windows(String)",e);}
    }
    
    
    
    
    
    
    private void showURL_mac(String url)
    {
    	try
    	{
    		if(isMac) url_mac.give(url);
    	}
    	catch(Exception e)
    	{Outside.err(this,"showURL_mac(String)",e);}
    }
    
    
    
    
    
    
    private void lingTooltip(JLabel label)
    {
    	try
    	{
    		lingTooltip.give(label);
    	}
    	catch(Exception e)
    	{Outside.err(this,"lingTooltip(JLabel)",e);}
    }
    
    
    
    



    
    
    
    
    
    
    
    private class JLinkLabel_windows extends JLabel implements MouseListener
    {
    	private Color COLOR_HIGHLIGHT = Color.GREEN;
    	private Color foreground;

    	public JLinkLabel_windows()
    	{
    		super();
    		addMouseListener(this);
    		setFocusable(true);
    		foreground = getForeground();
    		setToolTipText("WEB_clickToDisplayLink");
    		lingTooltip(this);
    	}

    	public void setForeground(Color foreground)
    	{
    		this.foreground = foreground;
    		super.setForeground(foreground);
    	}

    	public void mouseClicked(MouseEvent e) {}
    	public void mouseReleased(MouseEvent e) {}
    	public void mouseEntered(MouseEvent e)
    	{
    		super.setForeground(COLOR_HIGHLIGHT);
    	}
    	public void mouseExited(MouseEvent e)
    	{
    		super.setForeground(foreground);
    	}
    	public void mousePressed(MouseEvent e)
    	{
    		super.setForeground(foreground);
    		showURL_windows(getText());
    	}
    }
    
    
    
    
    
    
    
    
    
    
    private class JLinkLabel_mac extends JLabel implements MouseListener
    {
    	private Color COLOR_HIGHLIGHT = Color.RED;
    	private Color foreground;
    	
    	public JLinkLabel_mac()
    	{
    		super();
    		addMouseListener(this);
    		setFocusable(true);
    		foreground = getForeground();
    		setToolTipText("WEB_clickToDisplayLink");
    		lingTooltip(this);
    	}

    	public void setForeground(Color foreground)
    	{
    		this.foreground = foreground;
    		super.setForeground(foreground);
    	}

    	public void mouseClicked(MouseEvent e) {}
    	public void mouseReleased(MouseEvent e) {}
    	public void mouseEntered(MouseEvent e)
    	{
    		super.setForeground(COLOR_HIGHLIGHT);
    	}
    	public void mouseExited(MouseEvent e)
    	{
    		super.setForeground(foreground);
    	}
    	public void mousePressed(MouseEvent e)
    	{
    		super.setForeground(foreground);
    		showURL_mac(getText());
    	}
    }
}

