
package gus05.entity.gus.graphic.panel.screen.image;

import java.awt.Image;
import java.io.File;
import java.net.URL;

import javax.swing.JComponent;

import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;


public class ImageScreen implements Entity, Give, Graphic {

    public String getName()				{return "gus.graphic.panel.screen.image";}
    public String getCreationDate()		{return "2006.07.07";}

    
    private ScreenJPanel panel;

    public ImageScreen()
    {panel = new ScreenJPanel();}  
    
    
    public JComponent gui()
    {return panel;}
    
    
    
    public void give(Object obj) throws Exception
    {
    	if(obj==null)
        {
            panel.setImage(null);
            panel.repaint();
            return;
        }
        if(obj instanceof File)
        {
            panel.loadImage2((File)obj);
            panel.repaint();
            return;
        }
        
        if(obj instanceof URL)
        {
            panel.loadImage2((URL)obj);
            panel.repaint();
            return;
        }
        
        if(obj instanceof byte[])
        {
            panel.loadImage((byte[])obj);
            panel.repaint();
            return;
        }    
        
        if(obj instanceof Image)
        {
            panel.setImage((Image)obj);
            panel.repaint();
            return;
        }
        throw new Exception("invalid type : "+obj.getClass());
    }

}
