package gus05.entity.gus.graphic.progressbar.testprogress1;


import java.awt.Color;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Rectangle;

import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;

import javax.swing.JComponent;
import javax.swing.JProgressBar;
import javax.swing.plaf.metal.MetalProgressBarUI;



public class TestProgress1 implements Entity, Give, Graphic, Register, Retrieve {


    public String getName()				{return "gus.graphic.progressbar.testprogress1";}
    public String getCreationDate()		{return "2006.08.22";}


    private Color color_0 = Color.RED;
    private Color color_1 = Color.GREEN;
    
    private int size = 0;
    private int current = 0;
    private boolean[] states;

    private JProgressBar bar;
    
    private boolean end()
    {return current>=size;}
    
    

    public TestProgress1() throws Exception
    {
        bar = new JProgressBar();
        bar.setForeground(color_1);
        bar.setBorderPainted(false);
        bar.setStringPainted(true);
        bar.setUI(new TestProgressBarUI());
    }
    
    
    
    
    private void initialize(int size)
    {
        this.size = size;
        states = new boolean[size];
        current = 0;
        
        bar.setMaximum(size);
        bar.setValue(0);
    }



    public void give(Object obj) throws Exception
    {
        if(end())return;
        
        String state = (String)obj;
        if(state.equals("0")) {progress_0();return;}
        if(state.equals("1")) {progress_1();return;}
        
        throw new Exception("Invalid state: "+state);
    }
    
    
    
    private void progress_0()
    {
        states[current] = false;
        current++;
        bar.setValue(current);
    }
    
    private void progress_1()
    {
        states[current] = true;
        current++;
        bar.setValue(current);
    }



    public JComponent gui()
    {return bar;}


    

    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("size"))
        {
            int s = Integer.parseInt((String)obj);
            initialize(s);
            return;
        }
        if(key.equals("color_0"))
        {
            color_0 = (Color)obj;
            return;
        }
        if(key.equals("color_1"))
        {
            color_1 = (Color)obj;
            bar.setForeground(color_1);
            return;
        }
        throw new Exception("Unknown key: "+key);
    }

    


    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("size")) return ""+size;
        if(key.equals("current")) return ""+current;
        
        if(key.equals("keys")) return new String[]{"size","current"};
        throw new Exception("Unknown key: "+key);
    }


    
    
    private class TestProgressBarUI extends MetalProgressBarUI
    {
        public void paintDeterminate(Graphics g, JComponent c)
        {
            super.paintDeterminate(g,c);
            if(size==0) return;
            
            Insets b = progressBar.getInsets();
            Rectangle r = progressBar.getBounds();
            
            int h = r.height;
            int w = r.width;
            
            int y0 = b.top;
            int y1 = h - b.bottom - b.top;
            
            
            int dx = (int)(w/size);
            for(int i=0;i<current;i++) if(!states[i])
            {
                g.setColor(color_0);
                int x0 = (int)(w*i/size) + b.left;
                g.fillRect(x0,y0,dx+1,y1);
            }
        }
    }
    
    
}

