
package gus05.entity.gus.graphic.table.holder.map;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.table.AbstractTableModel;



class MapTableModel extends AbstractTableModel {

	
	private Map map;
	private List keys;
	
	private String keyName = "key";
	private String valueName = "value";
	
	public void setKeyName(String keyName)
	{
		this.keyName = keyName;
		fireTableStructureChanged();
	}
	
	public void setValueName(String valueName)
	{
		this.valueName = valueName;
		fireTableStructureChanged();
	}
	
	
	
	
	public void setMap(Map map_)
	{
	    map = map_;
	    if(map==null)
	    	keys = new Vector();
	    else keys = new Vector(map.keySet());
	    Collections.sort(keys);
	    fireTableDataChanged();
	}
	
	
	
	public int getRowCount()
	{return map!=null?map.size():0;}
	
	public int getColumnCount()
	{return 2;}
	
	
	
	public Object getValueAt(int x, int y)
	{
	    Object key = keys.get(x);
	    if(y==0)return key;
	    else return map.get(key);
	}
	
	public int indexForKey(String key)
	{return keys.indexOf(key);}
	
	
	
	
	public boolean isCellEditable(int x, int y)
	{return false;}
	
	
	public Class getColumnClass(int y)
	{return String.class;}
	
	
	public String getColumnName(int y)
	{
	    if(y==0)return keyName;
	    else return valueName;
	}
}
