package gus05.entity.gus.graphic.table.holder.map;


import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;

import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JViewport;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;



public class TableHolderMap extends DefaultSupport implements Entity, Give, Provide, Register, Graphic, ListSelectionListener, ActionListener {


    public String getName()				{return "gus.graphic.table.holder.map";}
    public String getCreationDate()		{return "2009.02.02";}




    private Service supportHolder;
    
    private JTable table;
    private MapTableModel model;
    private Map map;
    

    public TableHolderMap() throws Exception
    {
    	supportHolder = Outside.service(this,"gus.app.support.holder");
    	supportHolder.addActionListener(this);
    	
    	model = new MapTableModel();
    	table = new JTable(model);
    	table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    	table.getSelectionModel().addListSelectionListener(this);
    }
    
    
    
    public void give(Object obj) throws Exception
    {
    	map = (Map)obj;
    	supportHolder.give(map);
    	model.setMap(map);
    }
    
    
    
    public void actionPerformed(ActionEvent e)
    {model.setMap(map);}

    
    public JComponent gui()
    {return table;}


    
    public Object provide() throws Exception
    {
    	if(table.getSelectionModel().isSelectionEmpty()) return null;
    	int row = table.getSelectedRow();
    	return table.getValueAt(row,0);
   }
    
    
    
    public void register(String key, Object obj) throws Exception
	{
		if(key.equals("select")) {select((String)obj);return;}
		if(key.equals("columnKey")){model.setKeyName((String)obj);return;}
		if(key.equals("columnValue")){model.setValueName((String)obj);return;}
		
		throw new Exception("Unknown key: "+key);
	}
    
    
    
    
    
    
    
    private void select(String key)
    {
    	int index = model.indexForKey(key);
    	table.getSelectionModel().setSelectionInterval(index,index);
    	scrollToVisible(table,index,index);
    }

    private void scrollToVisible(JTable table, int rowIndex, int vColIndex)
    {
    	if (!(table.getParent() instanceof JViewport)) return;

    	JViewport viewport = (JViewport)table.getParent();
    	Rectangle rect = table.getCellRect(rowIndex, vColIndex, true);
    	Point pt = viewport.getViewPosition();
    	rect.setLocation(rect.x-pt.x, rect.y-pt.y);
    	viewport.scrollRectToVisible(rect);
    }
    
    
    
    
    
    public void valueChanged(ListSelectionEvent e)
	{selectionChanged();}
    
    
    private void selectionChanged()
    {send(this,"selectionChanged()");}
}

