package gus05.entity.gus.graphic.table.holder.map.gui1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.BevelBorder;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.Map;



public class TableHolderMapGui1 implements Entity, Support, Give, Provide, Graphic, Register, Retrieve {


    public String getName()				{return "gus.graphic.table.holder.map.gui1";}
    public String getCreationDate()		{return "2009.02.15";}


    private Service tableHolder;
    private Service labelHolder;
    
    private JPanel panel;
    private JLabel labelTitle;
    private JLabel labelSize;
    private JTable table;
    private Map map;




    public TableHolderMapGui1() throws Exception
    {
    	tableHolder = Outside.service(this,"gus.graphic.table.holder.map");
    	labelHolder = Outside.service(this,"gus.graphic.label.holder.colsize2");
    	
    	table = (JTable) tableHolder.gui();
    	labelSize = (JLabel) labelHolder.gui();
    	
    	labelTitle = new JLabel();
    	labelTitle.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
    	labelTitle.setHorizontalAlignment(JLabel.CENTER);
    	
        panel = new JPanel(new BorderLayout());
        panel.add(labelTitle,BorderLayout.NORTH);
        panel.add(new JScrollPane(table),BorderLayout.CENTER);
        panel.add(labelSize,BorderLayout.SOUTH);
    }



    public void give(Object obj) throws Exception
    {
    	map = (Map) obj;
    	tableHolder.give(map);
    	labelHolder.give(map);
    }



    public JComponent gui()
    {return panel;}



    public Object provide() throws Exception
    {return tableHolder.provide();}



    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("title")) {setTitle((String)obj);return;}
    	tableHolder.register(key, obj);
    }
    
    
    
    public Object retrieve(String key) throws Exception
    {
    	if(key.equals("table")) return table;
    	if(key.equals("labelSize")) return labelSize;
    	if(key.equals("labelTitle")) return labelTitle;
    	
    	if(key.equals("keys"))
    		return new String[]{"table","labelSize","labelTitle"};
		throw new Exception("Unknown key: "+key);
	}
    
    
    
    
    private void setTitle(String title)
    {labelTitle.setText(title);}
    
    
	public void addActionListener(ActionListener listener) {tableHolder.addActionListener(listener);}
	public void removeActionListener(ActionListener listener) {tableHolder.removeActionListener(listener);}
	public List listeners() {return tableHolder.listeners();}
	

}

