package gus05.entity.gus.graphic.textcomp.action.f1.japanesetyping;


import java.awt.Color;
import java.awt.event.KeyEvent;

import javax.swing.Action;
import javax.swing.KeyStroke;
import javax.swing.text.JTextComponent;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.framework.resources.ActionBuilder;



public class JapaneseTyping implements Entity, Give, Transform {


    public String getName()				{return "gus.graphic.textcomp.action.f1.japanesetyping";}
    public String getCreationDate()		{return "2006.11.10";}

    
    public static final Color ACTIVATED_COLOR = new Color(212,212,141);

    
    private Service typingHolder;
    private ActionBuilder actionBuilder;
    private KeyStroke japaneseTypingKey;

    
    public JapaneseTyping() throws Exception
    {
        typingHolder = Outside.service(this, "gus.japanese.typingholder");
        actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
        japaneseTypingKey = KeyStroke.getKeyStroke(KeyEvent.VK_F1,0);
    }



    public void give(Object obj) throws Exception
    {
        JTextComponent comp = (JTextComponent)obj;
        
        Holder1 holder = new Holder1(comp);
        Action action = actionBuilder.build("TEXTCOMP_typejapanese",holder);
        comp.getInputMap().put(japaneseTypingKey, action);
    }



    public Object transform(Object obj) throws Exception
    {
        Holder1 holder = new Holder1((JTextComponent)obj);
        return actionBuilder.build("TEXTCOMP_typejapanese",holder);
    }

    
    
    private class Holder1 implements Execute
    {
        private JTextComponent comp;
        private Color background0;
        private boolean activated = false;
        private Execute executeTyping;
        
        public Holder1(JTextComponent comp) throws Exception
        {
            this.comp = comp;
            executeTyping = (Execute) typingHolder.transform(comp);
        }
        
        public void execute() throws Exception
        {
            if(!comp.isEditable()) return;
            activated = !activated;
            if(activated)
            {
                background0 = comp.getBackground();
                comp.setBackground(ACTIVATED_COLOR);
            }
            else comp.setBackground(background0);
            executeTyping.execute();
        }
    }

}

