package gus05.entity.gus.graphic.textcomp.action.p.wrapline;


import java.awt.Event;
import java.awt.event.KeyEvent;

import javax.swing.Action;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.framework.resources.ActionBuilder;



public class WrapLine implements Entity, Give, Transform {


    public String getName()				{return "gus.graphic.textcomp.action.p.wrapline";}
    public String getCreationDate()		{return "2006.09.25";}



    private ActionBuilder actionBuilder;
    private KeyStroke wrapKey;
    
    public WrapLine() throws Exception
    {
        actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
        wrapKey = KeyStroke.getKeyStroke(KeyEvent.VK_P,Event.CTRL_MASK);
    }




    public void give(Object obj) throws Exception
    {
        JTextArea textArea = (JTextArea)obj;
        Wrap wrap = new Wrap(textArea);
        Action action = actionBuilder.build("TEXTCOMP_wrapline",wrap);
        textArea.getInputMap().put(wrapKey, action);
    }



    public Object transform(Object obj) throws Exception
    {
        Wrap wrap = new Wrap((JTextArea)obj);
        return actionBuilder.build("TEXTCOMP_wrapline",wrap);
    }


    
    
    private class Wrap implements Execute
    {
        private JTextArea textArea;
        public Wrap(JTextArea textArea){this.textArea = textArea;}
        
        public void execute() throws Exception
        {
            int p = textArea.getCaretPosition();
            boolean val = !textArea.getLineWrap();
            textArea.setLineWrap(val);
            
            textArea.requestFocus();
            textArea.setCaretPosition(p);
        }
    }
}

