package gus05.entity.gus.graphic.textfield.recall;


import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.framework.features.Register;



public class TextFieldRecall implements Entity, Give, Register {


    public String getName()				{return "gus.graphic.textfield.recall";}
    public String getCreationDate()		{return "2006.08.02";}



    private KeyStroke keyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER,KeyEvent.CTRL_MASK);
    

    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("keyStroke"))
        {keyStroke = (KeyStroke)obj;return;}
        
        throw new Exception("Unknown key: "+key);
    }



    public void give(Object obj) throws Exception
    {new Holder((JTextField)obj);}
    
    
    
    
    
    
    
    
    
    
    
    private class Holder implements DocumentListener
    {
        private JTextField textField;
        private String previous = "";
        
        public Holder(JTextField textField_)
        {
            this.textField = textField_;
            textField.getDocument().addDocumentListener(this);
            
            AbstractAction action = new AbstractAction(){
                public void actionPerformed(ActionEvent e)
                {replace();}};
            
            textField.getInputMap().put(keyStroke,action);
        } 
        private void replace()
        {textField.setText(previous);}
        
        public void update()
        {
            String text = textField.getText();
            if(!text.equals(""))previous = text; 
        }
        public void insertUpdate(DocumentEvent e) {update();}
        public void removeUpdate(DocumentEvent e) {update();}
        public void changedUpdate(DocumentEvent e) {}
    }


}

