package gus05.entity.gus.io.outputstream.builder;


import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.text.JTextComponent;

import gus05.framework.core.Entity;
import gus05.framework.features.Transform;



public class OutputStreamBuilder implements Entity, Transform {


    public String getName()				{return "gus.io.outputstream.builder";}
    public String getCreationDate()		{return "2006.08.06";}



    public Object transform(Object obj) throws Exception
    {
        if(obj==null)
            return new OutputStreamNull();
        if(obj instanceof PrintStream)
        	return obj;
        if(obj instanceof File)
            return new FileOutputStream((File)obj);
        if(obj instanceof JTextArea)
            return new OutputStreamJTextArea((JTextArea)obj);
        if(obj instanceof JLabel)
            return new OutputStreamJLabel((JLabel)obj);
        if(obj instanceof JTable)
            return new OutputStreamJTable((JTable)obj);
        if(obj instanceof JTextComponent)
            return new OutputStreamJTextComponent((JTextComponent)obj,true);
        if(obj instanceof StringBuffer)
            return new OutputStreamStringBuffer((StringBuffer)obj);
        
        throw new Exception("Invalid data type: "+obj.getClass().getName());
    }


}

