/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.io.outputstream.builder;

import java.io.OutputStream;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;


public class OutputStreamJTable extends OutputStream {

    private JTable gui;
    private StringBuffer buff;
    private boolean insertOnTop = false;
    
    
    
    public OutputStreamJTable(JTable gui)
    {
        this.gui = gui;
        buff = new StringBuffer();
    }
    
    
    
    public OutputStreamJTable(JTable gui, boolean insertOnTop)
    {
        this.gui = gui;
        this.insertOnTop = insertOnTop;
        buff = new StringBuffer();
    }

    
    
    
    
    public void write(int b)
    {
		buff.append((char)b);
		if((char)b=='\n')
		    commit();
    }
    
    
    
    
    private void commit()
    {
        String line = buff.toString();
        //System.out.println("commit(): "+line);
                
        buff = new StringBuffer();
        String[] cells = line.split("\t");
        
        int cellNumber = gui.getColumnCount();
        if(cells.length!=cellNumber)
        {
            cells = new String[cellNumber];
            for(int i=0;i<cellNumber;i++)
                cells[i] = "#E#"+line;
        }
            
        DefaultTableModel model = (DefaultTableModel)gui.getModel();
        
        if(insertOnTop) model.insertRow(0,cells);
        else model.addRow(cells);
    }

}
