package gus05.entity.gus.mail.account.mainaccount.changeaction;


import java.io.PrintStream;
import java.util.Map;

import javax.swing.Action;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Execute;
import gus05.framework.resources.ActionBuilder;



public class ChangeAction implements Entity, Provide, Execute {


    public String getName()				{return "gus.mail.account.mainaccount.changeaction";}
    public String getCreationDate()		{return "2009.10.10";}

    
    public static final String ACTIONID = "MAIL_changeAddress";

    private static final String KEY_LOGIN = "login";
    private static final String KEY_PASSWORD = "password";
    
    
    private Service askForRestart;
    private Service askLoginPassword;
    private ActionBuilder actionBuilder;
    
    private PrintStream out;
    private Map infoMap;
    
    private Action action;
    

    public ChangeAction() throws Exception
    {
    	askForRestart = Outside.service(this,"gus.app.restartapp.askforrestart");
    	askLoginPassword = Outside.service(this,"gus.security.askinfo.loginpasswordinit1");
    	actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
    	
    	out = (PrintStream) Outside.resource(this,"out");
    	infoMap = (Map) Outside.resource(this,"mailaccount.info");
    	
    	action = actionBuilder.build(ACTIONID,this);
    	askLoginPassword.register("title","Edit mail account informations");
    }


    public Object provide() throws Exception
    {return action;}

    
    
    
    public void execute() throws Exception
    {
    	String login = getInfo(KEY_LOGIN);
    	String password = getInfo(KEY_PASSWORD);
    	
    	if(login!=null && !login.equals("")) askLoginPassword.register("login",login);
    	String[] infos = (String[]) askLoginPassword.provide();
    	if(infos==null) return;
    	
    	String newLogin = infos[0];
    	String newPassword = infos[1];
    	
    	if(newLogin==null) return;
    	if(newPassword==null) return;
    	if(login.equals(newLogin) && password.equals(newPassword)) return;
    	
    	if(!login.equals(newLogin))
    		out.println("changing mail account with new address: "+newLogin);
    	else out.println("changing mail account: "+newLogin);
    	
    	setInfo(KEY_LOGIN,newLogin);
    	setInfo(KEY_PASSWORD,newPassword);
    	
    	askForRestart.execute();
    }


    
    
    private String getInfo(String key)
    {return infoMap.containsKey(key)?(String) infoMap.get(key):null;}
    
    private void setInfo(String key, String value)
    {infoMap.put(key,value);}


}

