package gus05.entity.gus.mail.account.mainaccount.statuslabel;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;



public class StatusLabel implements Entity, Graphic, ActionListener {


    public String getName()				{return "gus.mail.account.mainaccount.statuslabel";}
    public String getCreationDate()		{return "2009.05.03";}



    private Service account;
    private JLabel label;
    
    private Icon icon_disconnected;
    private Icon icon_connected;
    private Icon icon_aborted;


    public StatusLabel() throws Exception
    {
    	account = Outside.service(this,"gus.mail.account.mainaccount");
    	icon_disconnected = (Icon) Outside.resource(this,"icon#MAIL_hotmailDisconnectedState");
    	icon_connected = (Icon) Outside.resource(this,"icon#MAIL_hotmailConnectedState");
    	icon_aborted = (Icon) Outside.resource(this,"icon#MAIL_hotmailAbortedState");
    	
    	label = new JLabel(" ");
    	label.setIcon(icon_disconnected);
    	label.setToolTipText("not connected to hotmail account");
    	
    	account.addActionListener(this);
    }



    public JComponent gui()
    {return label;}
    
    
    
	public void actionPerformed(ActionEvent e)
	{
		String c = e.getActionCommand();
		if(c.equals("aborted()"))
		{
			label.setIcon(icon_aborted);
			label.setToolTipText("connection to hotmail account aborted");
		}
		else if(c.equals("connected()"))
		{
			label.setIcon(icon_connected);
			label.setToolTipText("connected to hotmail account");
		}
	}


}

