package gus05.entity.gus.mail.account.mainaccount2.cegetel;


import java.util.Properties;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.Transport;
import javax.mail.URLName;

import com.sun.mail.pop3.POP3SSLStore;

import gus05.framework.core.Entity;
import gus05.framework.features.Execute;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;



public class MainAccount2Cegetel implements Entity, Retrieve, Register, Execute {


    public String getName()				{return "gus.mail.account.mainaccount2.cegetel";}
    public String getCreationDate()		{return "2009.10.09";}

    
    
    public static final String SMTP_HOST = "smtp.cegetel.net";
    public static final int SMTP_PORT = 25; // valeur par dfaut
    
    public static final String POP_HOST = "pop.cegetel.net";
    public static final int POP_PORT = 110; // valeur par dfaut du pop3
    
    
    private String login;
    private String password;

    private Session transportSession;
    private Transport transport;
    
    private Session storeSession;
    private Store store;
    
    
    
    public void register(String key, Object obj) throws Exception
    {
		if(key.equals("login")) {login = (String) obj;return;}
		if(key.equals("password")) {password = (String) obj;return;}
		throw new Exception("Unknown key: "+key);
	}
    
    
    
    


    public Object retrieve(String key) throws Exception
    {
        if(key.equals("transport")) return getTransport();
        if(key.equals("store")) return getStore();
        
        if(key.equals("transportSession"))
        {getTransport(); return transportSession;}
        
        if(key.equals("storeSession"))
        {getStore(); return storeSession;}
        
        if(key.equals("keys")) return new String[]{"transport","store","transportSession","storeSession"};
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    
    
    
    public void execute() throws Exception
    {
    	if(transport!=null && !transport.isConnected())
    		transport.connect("smtp.gmail.com",login,password);
    	if(store!=null && !store.isConnected())
	    	store.connect();
	}
    
    

    
    private Transport getTransport() throws Exception
    {
    	if(transport!=null)
    	{
    		if(!transport.isConnected())
        		transport.connect(SMTP_HOST,login,password);
    		return transport;
    	}
    	if(login==null) throw new Exception("Login has not been initialized");
    	if(password==null) throw new Exception("Password has not been initialized");

    	Properties p = new Properties();
		p.put("mail.smtp.host", SMTP_HOST);
		p.put("mail.smtp.user", login);
		p.put("mail.smtp.port", ""+SMTP_PORT);
		p.put("mail.smtp.starttls.enable","true");
		p.put("mail.smtp.auth", "true");
		p.put("mail.smtp.debug", "true");
		p.put("mail.smtp.socketFactory.port", ""+SMTP_PORT);
		p.put("mail.smtp.socketFactory.class", "javax.net.ssl.SSLSocketFactory");
		p.put("mail.smtp.socketFactory.fallback", "false");

		transportSession = Session.getDefaultInstance(p, null);
    	transport = transportSession.getTransport("smtp");
    	transport.connect(SMTP_HOST,login,password);
    	
    	return transport;
    }

    
    
    
    



    private Store getStore() throws Exception
    {
    	if(store!=null)
    	{
    		if(!store.isConnected())
    	    	store.connect();
    		return store;
    	}
    	if(login==null) throw new Exception("Login has not been initialized");
    	if(password==null) throw new Exception("Password has not been initialized");

    	Properties p = new Properties();
        p.setProperty("mail.pop3.socketFactory.class", "javax.net.ssl.SSLSocketFactory");
        p.setProperty("mail.pop3.socketFactory.fallback","false");
        p.setProperty("mail.pop3.port",""+POP_PORT);
        p.setProperty("mail.pop3.socketFactory.port",""+POP_PORT);
        
        URLName url = new URLName("pop3",POP_HOST,POP_PORT,"",login, password);
        
        storeSession = Session.getInstance(p, null);
        Store store = new POP3SSLStore(storeSession, url);
        store.connect();
    	
    	return store;
    }
	
}

