package gus05.entity.gus.mail.send.app.maingui;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;

import java.awt.BorderLayout;



public class MailSendMainGui implements Entity, Graphic {


    public String getName()				{return "gus.mail.send.app.maingui";}
    public String getCreationDate()		{return "2009.05.02";}


    private Service autoSenderGui;
    private Service mailingGui;
    private Service historicGui;
    private Service logArea;
    private Service persist;
    
    private Service onlineLabel;
    private Service hotmailStatusLabel;
    private Service autoSenderStatusLabel;
    private Service sendLabel;
    
    
    private JPanel panel;




    public MailSendMainGui() throws Exception
    {
    	autoSenderGui = Outside.service(this,"gus.mail.send.autosender.gui1");
    	mailingGui = Outside.service(this,"gus.mail.send.mailingsender.gui");
    	historicGui = Outside.service(this,"gus.mail.send.mailsender.historic");
    	logArea = Outside.service(this,"gus.management.console.log1");
    	persist = Outside.service(this,"gus.graphic.persistence.persistence1");
    	
    	onlineLabel = Outside.service(this,"gus.watching.online.label");
    	hotmailStatusLabel = Outside.service(this,"gus.mail.account.mainaccount.statuslabel");
    	autoSenderStatusLabel = Outside.service(this,"gus.mail.send.autosender.statuslabel");
        sendLabel = Outside.service(this,"gus.mail.send.mailsender.sendlabel");
        
        JTabbedPane tab = new JTabbedPane();
        tab.addTab("Mailing sender", mailingGui.gui());
        tab.addTab("Automatic sender", autoSenderGui.gui());
        tab.addTab("Historic", historicGui.gui());
        tab.addTab("Log file", logArea.gui());
        
        persist.register(getName()+"_tab",tab);
        
        JToolBar bar = new JToolBar();
    	bar.setFloatable(false);
    	
    	bar.add(autoSenderStatusLabel.gui());
    	bar.addSeparator();
    	bar.add(hotmailStatusLabel.gui());
    	bar.addSeparator();
    	bar.add(onlineLabel.gui());
    	bar.addSeparator();
        
        JPanel p_bottom = new JPanel(new BorderLayout());
        p_bottom.add(sendLabel.gui(),BorderLayout.CENTER);
        p_bottom.add(bar,BorderLayout.EAST);
        
        panel = new JPanel(new BorderLayout());
        panel.add(tab,BorderLayout.CENTER);
        panel.add(p_bottom,BorderLayout.SOUTH);
    }



    public JComponent gui()
    {return panel;}


}

