package gus05.entity.gus.mail.send.autosender.gui1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;



public class MailAutoSenderGui1 implements Entity, Graphic, ActionListener {


    public String getName()				{return "gus.mail.send.autosender.gui1";}
    public String getCreationDate()		{return "2007.12.18";}


    private Service autoSender;
    private Service persistFile;
    private Service explorer1;
    private Service explorer2;
    private Service explorer3;
    
    private File storeDir;
    private File failedDir;
    private File sentDir;
    
    private JPanel panel;
    private JButton button;



    public MailAutoSenderGui1() throws Exception
    {
    	autoSender = Outside.service(this,"gus.mail.send.autosender");
    	persistFile = Outside.service(this,"gus.persistence.fileholder");
    	explorer1 = Outside.service(this,"gus.file.explorer.editingexplorer1.v-1");
    	explorer2 = Outside.service(this,"gus.file.explorer.editingexplorer1.v-2");
    	explorer3 = Outside.service(this,"gus.file.explorer.editingexplorer1.v-3");
    	
    	storeDir = (File) Outside.resource(this,"storeDir");
        failedDir = (File) Outside.resource(this,"failedDir");
        sentDir = (File) Outside.resource(this,"sentDir");
        
        explorer1.give(storeDir);
        explorer2.give(failedDir);
        explorer3.give(sentDir);
    	
    	persistFile.register(getName()+"_explorer1",explorer1);
    	persistFile.register(getName()+"_explorer2",explorer2);
    	persistFile.register(getName()+"_explorer3",explorer3);
        
    	autoSender.register("storeDir",explorer1.provide());
    	autoSender.register("failedDir",explorer2.provide());
    	autoSender.register("sentDir",explorer3.provide());
        
    	button = new JButton("Send now");
    	button.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{sendMails();}
		});
    	
    	JPanel p_center = new JPanel(new GridLayout(1,3));
    	p_center.add(titled(explorer1.gui(),"WAITING",Color.GRAY));
    	p_center.add(titled(explorer2.gui(),"SENT",Color.BLUE));
    	p_center.add(titled(explorer3.gui(),"FAILED",Color.RED));
        
        panel = new JPanel(new BorderLayout());
        panel.add(p_center,BorderLayout.CENTER);
        panel.add(button,BorderLayout.SOUTH);
        
        autoSender.addActionListener(this);
    }
    
    
    
    private JPanel titled(JComponent c, String title, Color color)
    {
    	JLabel label = new JLabel(title);
    	label.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
    	label.setHorizontalAlignment(JLabel.CENTER);
    	label.setFont(label.getFont().deriveFont(Font.BOLD));
    	label.setForeground(color);
    	
    	JPanel p = new JPanel(new BorderLayout());
    	p.add(label,BorderLayout.NORTH);
    	p.add(c,BorderLayout.CENTER);
    	return p;
    }



    public JComponent gui()
    {return panel;}
    
    
	public void actionPerformed(ActionEvent e)
	{updateGui();}


	
	
	private void sendMails()
	{
		try{autoSender.execute();}
		catch(Exception e)
		{Outside.err(this,"sendMails()",e);}
	}
	
	
	
	
	private void updateGui()
	{
		try
		{
			explorer1.execute();
			explorer2.execute();
			explorer3.execute();
		}
		catch(Exception e)
		{Outside.err(this,"updateGui()",e);}
	}
	
}

