package gus05.entity.gus.mail.send.autosender.statuslabel;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;



public class StatusLabel implements Entity, Graphic, ActionListener {


    public String getName()				{return "gus.mail.send.autosender.statuslabel";}
    public String getCreationDate()		{return "2009.05.03";}



    private Service autoSender;
    
    private JLabel label;
    private Icon icon_watching;
    

    public StatusLabel() throws Exception
    {
    	autoSender = Outside.service(this,"gus.mail.send.autosender");
    	icon_watching = (Icon) Outside.resource(this,"icon#FILE_dico_file");
    	
    	label = new JLabel(" ");
    	checkStatus();
    	autoSender.addActionListener(this);
    }



    public JComponent gui()
    {return label;}



    public void actionPerformed(ActionEvent e)
    {checkStatus();}
    
    
    
    
    private void checkStatus()
    {
    	try
    	{
    		boolean activated = autoSender.filter(null);
    		if(activated)
    		{
    			label.setIcon(icon_watching);
    			label.setToolTipText("auto sender is activated");
    		}
    		else
    		{
    			label.setIcon(null);
    			label.setToolTipText(null);
    		}
    	}
    	catch(Exception e)
    	{Outside.err(this,"checkStatus()",e);}
    }


}

