package gus05.entity.gus.mail.send.mail1;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Date;

import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class SendMail1 implements Entity, Give {


    public String getName()				{return "gus.mail.send.mail1";}
    public String getCreationDate()		{return "2007.12.17";}



    private Service account;
    private Service sender;
    
    private Session session;
    private String login;
    private Message message;
    
    private InternetAddress[] addresses;
    private File[] attachedFiles;
    
    private String to;
    private String files;
    private String subject;
    private String text;
    
    
    public SendMail1() throws Exception
    {
        account = Outside.service(this,"gus.mail.account.mainaccount");
        sender = Outside.service(this,"gus.mail.send.mailsender");
    }



    public void give(Object obj) throws Exception
    {
        File f = (File)obj;
        
        login = (String) account.retrieve("login");
        session = (Session) account.retrieve("session");
        
        buildMessage(f);
        sender.register(to,new Object[]{message,addresses});
    }
    
    
    
    
    
    
    private void buildMessage(File f) throws Exception
    {
        FileInputStream fis = new FileInputStream(f);
        InputStreamReader isr = new InputStreamReader(fis);
        BufferedReader br = new BufferedReader(isr);
        
        to = br.readLine(); // premire ligne = adresse de destination
        subject = br.readLine(); // deuxime ligne = objet du mail
        files = br.readLine(); // troisime ligne = pices jointes
        text = readNext(br); // autres lignes = contenu du mail
        
        fis.close();
        
        addresses = InternetAddress.parse(to, true);
        attachedFiles = parseFiles(files);
        
        message = new MimeMessage(session);
        message.setSentDate(new Date());
        message.setFrom(new InternetAddress(login));
        message.setRecipients(Message.RecipientType.TO,addresses);
        message.setSubject(subject);
        
        if(attachedFiles==null) message.setText(text);
        else
        {
            MimeBodyPart mbp1 = new MimeBodyPart();
            mbp1.setText(text);
            
            Multipart mp = new MimeMultipart();
            mp.addBodyPart(mbp1);
            
            for(int i=0;i<attachedFiles.length;i++)
            {
                MimeBodyPart mbp = new MimeBodyPart();
                mbp.attachFile(attachedFiles[i]);
                mp.addBodyPart(mbp);
            }
            message.setContent(mp);
        }
    }


    
    
    private String readNext(BufferedReader br) throws IOException
    {
        StringBuffer b = new StringBuffer();
        String line;
        while((line=br.readLine())!=null)
        b.append(line+"\n");
        return b.toString();
    }
    
    
    
    private File[] parseFiles(String files) throws Exception
    {
        if(files.equals("")) return null;
        
        String[] n = files.split("[,;]");
        File[] f = new File[n.length];
        for(int i=0;i<f.length;i++)
        {
            f[i] = new File(n[i]);
            if(!f[i].exists()) throw new Exception("file "+f[i]+" does not exist");
        }
        return f;
    }
}

