package gus05.entity.gus.mail.send.mail2;


import java.io.File;
import java.util.Date;
import java.util.Map;

import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class SendMail2 implements Entity, Give {


    public String getName()				{return "gus.mail.send.mail2";}
    public String getCreationDate()		{return "2008.05.19";}

    
    public static final String HEADER_NOTIFICATION = "Disposition-Notification-To";
    

    private Service account;
    //private Service validator;
    private Service sender;
    
    private Session session;
    private String login;
    private Message message;
    
    private InternetAddress[] addresses;
    private InternetAddress fromAddress;
    private File[] attachedFiles;
    
    private String to;
    private String from_name;
    private String files;
    private String subject;
    private String text;
    private boolean confirmReading;
    private boolean testing;
    
    
    public SendMail2() throws Exception
    {
        account = Outside.service(this,"gus.mail.account.mainaccount");
        //validator = Outside.service(this,"gus.mail.validator.emailaddress");
        sender = Outside.service(this,"gus.mail.send.mailsender");
    }



    public void give(Object obj) throws Exception
    {
        Map map = (Map)obj;
        
        login = (String) account.retrieve("login");
        session = (Session) account.retrieve("session");
        
        fromAddress = new InternetAddress(login);
        
        buildMessage(map);
        
        if(!testing)
        sender.register(to,new Object[]{message,addresses});
    }
    
    
    
    
    
    
    
    private void buildMessage(Map map) throws Exception
    {
        to = (String) map.get(MAIL.KEY_TO);
        from_name = (String) map.get(MAIL.KEY_FROM_NAME);
        subject = (String) map.get(MAIL.KEY_SUBJECT);
        files = (String) map.get(MAIL.KEY_FILES);
        text = (String) map.get(MAIL.KEY_CONTENT);
        confirmReading = booleanValue(map,MAIL.KEY_CONFIRM_READING);
        testing = booleanValue(map,MAIL.KEY_TESTING);
        
        addresses = InternetAddress.parse(to, true);
        attachedFiles = parseFiles(files);
        
        fromAddress.setPersonal(from_name);
        
        message = new MimeMessage(session);
        message.setSentDate(new Date());
        message.setFrom(fromAddress);
        message.setRecipients(Message.RecipientType.TO,addresses);
        message.setSubject(subject);
        
        if(confirmReading)
        {
        	//String value = "Reading confirmation <"+fromAddress.getAddress()+">";
        	String value = fromAddress.getAddress();
        	message.setHeader(HEADER_NOTIFICATION,value);
        }
        
        
        if(attachedFiles==null) message.setText(text);
        else
        {
            MimeBodyPart mbp1 = new MimeBodyPart();
            mbp1.setText(text);
            
            Multipart mp = new MimeMultipart();
            mp.addBodyPart(mbp1);
            
            for(int i=0;i<attachedFiles.length;i++)
            {
                MimeBodyPart mbp = new MimeBodyPart();
                mbp.attachFile(attachedFiles[i]);
                mp.addBodyPart(mbp);
            }
            message.setContent(mp);
        }
    }
    
    
    
    
    
    
    
    private File[] parseFiles(String files) throws Exception
    {
        if(files.equals("")) return null;
        
        String[] n = files.split("[,;]");
        File[] f = new File[n.length];
        for(int i=0;i<f.length;i++)
        {
            f[i] = new File(n[i]);
            if(!f[i].exists()) throw new Exception("file "+f[i]+" does not exist");
        }
        return f;
    }
    
    
    
    private boolean booleanValue(Map map, String key)
    {
    	if(!map.containsKey(key)) return false;
    	String value = (String) map.get(key);
    	return value.toLowerCase().equals("true");
    }
}

