package gus05.entity.gus.mail.send.mailingsender;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Register;



public class MailingSender implements Entity, Give, Register {


    public String getName()				{return "gus.mail.send.mailingsender";}
    public String getCreationDate()		{return "2009.05.02";}


    private Service sendMail;
    private Object progress;
    private Map map;
    
    private Object obj_mailingList;
    private Object obj_from_name;
    private Object obj_files;
    private Object obj_subject;
    private Object obj_text;
    private Object obj_confirmReading;
    private Object obj_testing;
    
    private boolean stop = false;
    private int number_total;
    private int number_sent;
    private int number_failed;
    
    

    public MailingSender() throws Exception
    {
    	sendMail = Outside.service(this,"gus.mail.send.mail2");
    }


    
    public void register(String key, Object obj) throws Exception
	{
    	if(key.equals("stop")) {stop = true; return;}
    	if(key.equals("progress")) {progress = obj; return;}
    	throw new Exception("Unknown key: "+key);
	}
    
    

    public void give(Object obj) throws Exception
    {
    	map = (Map) obj;
    	
    	stop = false;
    	number_total = 0;
    	number_sent = 0;
    	number_failed = 0;
    	
    	obj_mailingList = getData(MAIL.KEY_TO);
        obj_from_name = getData(MAIL.KEY_FROM_NAME);
        obj_subject = getData(MAIL.KEY_SUBJECT);
        obj_files = getData(MAIL.KEY_FILES);
        obj_text = getData(MAIL.KEY_CONTENT);
        obj_confirmReading = getData(MAIL.KEY_CONFIRM_READING);
        obj_testing = getData(MAIL.KEY_TESTING);

        List mailingList = toList(obj_mailingList);
        if(progress==null) processMailing(mailingList);
        else processMailing_p(mailingList);
    }
    
    
    
    
    
    private void processMailing(List mailingList)
    {
    	for(int i=0;i<mailingList.size();i++)
        {
        	String mail = (String) mailingList.get(i);
        	if(stop) return;
        	handleMail(mail,i);
        }
    }
    
    
    
    
    private void processMailing_p(List mailingList) throws Exception
    {
    	((Register)progress).register("size",""+mailingList.size());
    	Give g = (Give) progress;
    	
    	for(int i=0;i<mailingList.size();i++)
        {
        	String mail = (String) mailingList.get(i);
        	if(stop) return;
        	boolean r = handleMail(mail,i);
        	
        	if(r) g.give("1");
        	else g.give("0");
        }
    }
    
    
    
    

    
    
    private boolean handleMail(String mail, int index)
    {
    	number_total++;
    	try
    	{
        	Map m = buildMailMap(mail,index);
        	sendMail.give(m);
        	number_sent++;
        	return true;
    	}
    	catch(Exception e)
    	{
    		Outside.err(this,"handleMail(String,int)",e);
    		number_failed++;
    		return false;
    	}
    }

    
    
    
    
    
    private Map buildMailMap(String mail, int index) throws Exception
    {
    	String to = mail;
    	String from_name = findValue(obj_from_name,mail,index);
    	String subject = findValue(obj_subject,mail,index);
    	String files = findValue(obj_files,mail,index);
    	String text = findValue(obj_text,mail,index);
    	String confirmReading = findValue(obj_confirmReading,mail,index);
    	String testing = findValue(obj_testing,mail,index);
    	
    	HashMap m = new HashMap();
    	m.put(MAIL.KEY_TO,to);
    	m.put(MAIL.KEY_FROM_NAME,from_name);
    	m.put(MAIL.KEY_SUBJECT,subject);
    	m.put(MAIL.KEY_FILES,files);
    	m.put(MAIL.KEY_CONTENT,text);
    	m.put(MAIL.KEY_CONFIRM_READING,confirmReading);
    	m.put(MAIL.KEY_TESTING,testing);
    	
    	return m;
    }
    
    
    
    
    
    
    private Object getData(String key) throws Exception
    {
    	Object data = map.get(key);
    	checkType(data);
    	return data;
    }
    
    
    private String findValue(Object data, String key, int index) throws Exception
    {
    	if(data instanceof String) return (String) data;
    	if(data instanceof List) return (String) ((List)data).get(index);
    	return (String) ((Map)data).get(key);
    }
    
    
    
    
    
    
    private void checkType(Object data) throws Exception
    {
    	if(data instanceof String) return;
    	if(data instanceof List) return;
    	if(data instanceof Map) return;
    	
    	throw new Exception("invalid data type: "+data.getClass().getName());
    }
    
    
    
    private List toList(Object obj) throws Exception
    {
    	if(obj instanceof List) return (List)obj;
    	if(obj instanceof String)
    	{
    		String s = (String) obj;
    		ArrayList list = new ArrayList();
    		list.add(s);
    		return list;
    	}
    	throw new Exception("Invalid data type: "+obj.getClass().getName());
    }
	
}

