package gus05.entity.gus.mail.send.mailingsender.gui.buildmap;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Graphic;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;



public class BuildMapGui implements Entity, Provide, Graphic {


    public String getName()				{return "gus.mail.send.mailingsender.gui.buildmap";}
    public String getCreationDate()		{return "2009.05.03";}

    
    public static final String KEY_TO = "to";
    public static final String KEY_FROM = "from";
    public static final String KEY_SUBJECT = "subject";
    public static final String KEY_FILES = "files";
    public static final String KEY_CONTENT = "content";
    public static final String KEY_CONFIRMATION = "confirmation";
    public static final String KEY_TEST = "test";
    
    public static final String VALUE_TRUE = "true";
    public static final String VALUE_FALSE = "false";
    
    
    

    private Service persistFile;
    private Service persistGui;
    private Service form;
    private Service explorer;
    private Service quickReplace;
	private Service undo;
	
    private Map area0_map;
    
    private JTabbedPane tab;
    private JTextArea area0;
    private JTextArea area1;
    private JTextArea area2;
    private JTextArea area3;
    private JTextArea area4;
    private JTextArea area5;

    private JRadioButton b_to_area0;
    private JRadioButton b_to_area1;

    private JRadioButton b_from_area0;
    private JRadioButton b_from_area2;

    private JRadioButton b_subject_area0;
    private JRadioButton b_subject_area3;
    
    private JRadioButton b_files_area0;
    private JRadioButton b_files_area4;
    
    private JRadioButton b_content_area0;
    private JRadioButton b_content_area5;
    
    private JRadioButton b_confirmation_area0;
    private JRadioButton b_confirmation_yes;
    private JRadioButton b_confirmation_no;
    
    private JRadioButton b_test_yes;
    private JRadioButton b_test_no;
    
    
    
    


    public BuildMapGui() throws Exception
    {
    	persistFile = Outside.service(this,"gus.persistence.fileholder");
    	persistGui = Outside.service(this,"gus.graphic.persistence.persistence1");
    	explorer = Outside.service(this,"gus.file.explorer.editingexplorer1");
    	form = Outside.service(this,"gus.graphic.panel.form1");
    	quickReplace = Outside.service(this,"gus.graphic.textcomp.action.w.quickreplace");
		undo = Outside.service(this,"gus.graphic.textcomp.action.z.undo");
		
    	persistFile.register(getName()+"_explorer",explorer);
    	
    	area0 = area("area0");
    	area1 = area("area1");
    	area2 = area("area2");
    	area3 = area("area3");
    	area4 = area("area4");
    	area5 = area("area5");
    	
    	quickReplace.give(area0);
		undo.give(area0);
		undo.give(area1);
		undo.give(area2);
		undo.give(area3);
		undo.give(area4);
		undo.give(area5);
    	
    	b_to_area0 =				radio("b_to_area0","area 0",false);
    	b_from_area0 =				radio("b_from_area0","area 0",false);
    	b_subject_area0 =			radio("b_subject_area0","area 0",false);
    	b_files_area0 =				radio("b_files_area0","area 0",false);
    	b_content_area0 =			radio("b_content_area0","area 0",false);
    	b_confirmation_area0 =		radio("b_confirmation_area0","area 0",false);
    	
    	b_to_area1 =				radio("b_to_area1","area 1",true);
    	b_from_area2 =				radio("b_from_area2","area 2",true);
    	b_subject_area3 =			radio("b_subject_area3","area 3",true);
    	b_files_area4 =				radio("b_files_area4","area 4",true);
    	b_content_area5 =			radio("b_content_area5","area 5",true);
    	
    	b_confirmation_yes =		radio("b_confirmation_yes","yes",false);
    	b_confirmation_no =			radio("b_confirmation_no","no",true);
    	b_test_yes =				radio("b_test_yes","yes",false);
    	b_test_no =					radio("b_test_no","no",true);
    	
    	
    	form.register(KEY_TO, p(b_to_area0,b_to_area1));
    	form.register(KEY_FROM, p(b_from_area0,b_from_area2));
    	form.register(KEY_SUBJECT, p(b_subject_area0,b_subject_area3));
    	form.register(KEY_FILES, p(b_files_area0,b_files_area4));
    	form.register(KEY_CONTENT, p(b_content_area0,b_content_area5));
    	form.register(KEY_CONFIRMATION, p(b_confirmation_area0,b_confirmation_yes,b_confirmation_no));
    	form.register(KEY_TEST, p(b_test_yes,b_test_no));
    	
    	
    	JTabbedPane tab1 = new JTabbedPane();
    	tab1.addTab("Area1: to",new JScrollPane(area1));
    	tab1.addTab("Area2: from",new JScrollPane(area2));
    	tab1.addTab("Area3: subject",new JScrollPane(area3));
    	tab1.addTab("Area4: files",new JScrollPane(area4));
    	tab1.addTab("Area5: content",new JScrollPane(area5));
    	
    	
    	
    	JPanel panelArea = new JPanel(new BorderLayout());
        panelArea.add(new JScrollPane(area0),BorderLayout.CENTER);
    	
        JPanel panelSetting = new JPanel(new BorderLayout());
        panelSetting.add(form.gui(),BorderLayout.WEST);
        panelSetting.add(tab1,BorderLayout.CENTER);
    	
        
        tab = new JTabbedPane();
        tab.addTab("Settings",panelSetting);
        tab.addTab("Area 0",panelArea);
        tab.addTab("Files root",explorer.gui());
    }
    
    
    
    private JPanel p(JRadioButton b1, JRadioButton b2)
    {
    	JPanel p = new JPanel(new FlowLayout(FlowLayout.LEFT));
        p.setLayout(new BoxLayout(p,BoxLayout.X_AXIS));
    	p.add(b1);p.add(b2);
    	
    	ButtonGroup g = new ButtonGroup();
    	g.add(b1);g.add(b2);
    	
    	JPanel pp = new JPanel(new BorderLayout());
    	pp.add(p,BorderLayout.WEST);
    	return pp;
    }
    
    
    
    
    private JPanel p(JRadioButton b1, JRadioButton b2, JRadioButton b3)
    {
    	JPanel p = new JPanel(new FlowLayout(FlowLayout.LEFT));
        p.setLayout(new BoxLayout(p,BoxLayout.X_AXIS));
    	p.add(b1);p.add(b2);p.add(b3);
    	
    	ButtonGroup g = new ButtonGroup();
    	g.add(b1);g.add(b2);g.add(b3);
    	
    	JPanel pp = new JPanel(new BorderLayout());
    	pp.add(p,BorderLayout.WEST);
    	return pp;
    }
    
    
    
    private void persist(String key, JComponent comp) throws Exception
    {persistGui.register(getName()+"_"+key,comp);}

    
    private JRadioButton radio(String key, String text, boolean isSelected) throws Exception
    {
    	JRadioButton b = new JRadioButtonBold(text,isSelected);
    	persist(key,b);
    	return b;
    }
    
    private JTextArea area(String key) throws Exception
    {
    	JTextArea area = new JTextArea();
    	persist(key,area);
    	return area;
    }
    
    
    


    public JComponent gui()
    {return tab;}



    public Object provide() throws Exception
    {
    	String input = area0.getText();
    	String filesRoot = findFilesRoot();
    	
    	if(usingArea0() && !input.equals(""))
    		area0_map = buildArea0Map(input);
    	else area0_map = null;
    	
    	Object obj_to = to();
    	if(obj_to==null) return null;
    	    	
    	HashMap m = new HashMap();
    	m.put(MAIL.KEY_TO,obj_to);
    	m.put(MAIL.KEY_FROM_NAME,from());
    	m.put(MAIL.KEY_SUBJECT,subject());
    	m.put(MAIL.KEY_FILES,files(filesRoot));
    	m.put(MAIL.KEY_CONTENT,content());
    	m.put(MAIL.KEY_CONFIRM_READING,confirmation());
    	m.put(MAIL.KEY_TESTING,test());
        return m;
    }
    
    
    
    
    
    private boolean usingArea0()
    {
    	return b_confirmation_area0.isSelected() ||
    		b_content_area0.isSelected() ||
    		b_to_area0.isSelected() ||
    		b_from_area0.isSelected() ||
    		b_subject_area0.isSelected() ||
    		b_files_area0.isSelected();
    }
    
    
    
    
    
    
    private Map buildArea0Map(String text) throws Exception
    {
    	HashMap map = new HashMap();
    	String[] lines = text.split("[\n\r]+");
    	if(lines.length<2) throw new Exception("Invalid area0 input");
    	
    	String[] fields = lines[0].split("\t");
    	int fieldNumber = fields.length;
    	if(fieldNumber<2) throw new Exception("Invalid area0 input");
    	
    	int index_to = findIndexTo(fields);
    	if(index_to==-1) throw new Exception("Invalid area0 input");
    	
    	ArrayList list = new ArrayList();
    	map.put(fields[index_to],list);
    	for(int i=0;i<fieldNumber;i++) if(i!=index_to)
		map.put(fields[i],new HashMap());
    	
    	
    	
    	for(int i=1;i<lines.length;i++)
    	{
    		String[] n = lines[i].split("\t");
    		if(n.length!=fieldNumber)
    			 throw new Exception("Invalid area0 input at line: "+i);
    		
    		String to = n[index_to];
    		list.add(to);
    		
    		for(int j=0;j<fieldNumber;j++) if(j!=index_to)
    		{
    			String value = formatValue(n[j]);
    			String field = fields[j];
    			Map m = (Map) map.get(field);
    			m.put(to,value);
    		}
    	}
    	return map;
    }
    
    
    
    
    private String formatValue(String value)
    {
    	String v = value.toLowerCase();
    	if(v.equals("yes") || v.equals("oui")) return VALUE_TRUE;
    	if(v.equals("no") || v.equals("non")) return VALUE_FALSE;
    	return value;
    }
    
    
    
    
    
    
    private int findIndexTo(String[] fields)
    {
    	for(int i=0;i<fields.length;i++)
    		if(fields[i].equals(KEY_TO)) return i;
    	return -1;
    }
    
    
    
    private String findFilesRoot() throws Exception
    {
    	File dir = (File) explorer.provide();
    	if(dir==null) return "";
    	return dir.getAbsolutePath();
    }
    
    
    
    
    private String formatFilePath(String path, String root)
    {
    	String s = File.separator;
    	String path1 = root+s+path;
    	while(path1.contains(s+s))
    		path1 = path1.replace(s+s,s);
    	return path1;
    }
    
    
    
    private String formatFilePathSequence(String sequence, String root)
    {
    	if(!sequence.contains(";"))
    		return formatFilePath(sequence,root);
    	
    	String[] n = sequence.split(";");
    	StringBuffer b = new StringBuffer();
    	for(int i=0;i<n.length;i++)
    	{
    		String newPath = formatFilePath(n[i],root);
    		b.append(newPath);
    		if(i<n.length-1) b.append(";");
    	}
    	return b.toString();
    }
    
    
    
    
    
    
    
    private Map formatFilePathMap(Map map, String root)
    {
    	HashMap m = new HashMap();
    	
    	Iterator it = map.keySet().iterator();
    	while(it.hasNext())
    	{
    		String key = (String) it.next();
    		String value = (String) map.get(key);
    		m.put(key,formatFilePathSequence(value,root));
    	}
    	return m;
    }
    
    
    
    
    
    
    
    
    
    
    
    private Object to()
    {
    	if(b_to_area0.isSelected())
    		return area0_map.get(KEY_TO);

    	String s = area1.getText();
    	if(s.equals("")) return null;
    	
    	String[] n = s.split("[\n\r]+");
    	if(n.length==1) return n[0];
    	return Arrays.asList(n);
    }
    

    
    private Object from()
    {
    	if(b_from_area0.isSelected())
    		return area0_map.get(KEY_FROM);
    	return area2.getText();
    }
    
    
    
    private Object subject()
    {
    	if(b_subject_area0.isSelected())
    		return area0_map.get(KEY_SUBJECT);
    	return area3.getText();
    }
    
    
    
    private Object files(String root)
    {
    	if(root.equals(""))
    	{
    		if(b_files_area0.isSelected())
        		return area0_map.get(KEY_FILES);
        	return area4.getText();
    	}
    	else
    	{
    		if(b_files_area0.isSelected())
        		return formatFilePathMap((Map)area0_map.get(KEY_FILES),root);
        	return formatFilePathSequence(area4.getText(),root);
    	}
    }
    
    
    
    private Object content()
    {
    	if(b_content_area0.isSelected())
    		return area0_map.get(KEY_CONTENT);
    	return area5.getText();
    }
    
    
    
    private Object confirmation()
    {
    	if(b_confirmation_area0.isSelected())
    		return area0_map.get(KEY_CONFIRMATION);
    	if(b_confirmation_yes.isSelected()) return VALUE_TRUE;
    	return VALUE_FALSE;
    }
    
    
    
    private Object test()
    {
    	if(b_test_yes.isSelected()) return VALUE_TRUE;
    	return VALUE_FALSE;
    }
    
    
    
    
    
    
    
    
    
    
}

