package gus05.entity.gus.mail.send.mailsender;


import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

import javax.mail.Message;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;



public class MailSender extends DefaultSupport implements Entity, Register, Provide, Retrieve {


    public String getName()				{return "gus.mail.send.mailsender";}
    public String getCreationDate()		{return "2008.06.16";}

    

    private Service account;
    private Map storeMap;
    private PrintStream out;
    
    private String to;
    private Message message;
    private InternetAddress[] addresses;
    private String sendTime;
    
    
    public MailSender() throws Exception
    {
        account = Outside.service(this,"gus.mail.account.mainaccount");
        storeMap = (Map) Outside.resource(this,"defaultdatamap");
        out = (PrintStream) Outside.resource(this,"out");
    }



    public void register(String key, Object obj) throws Exception
    {
    	Object[] info = (Object[]) obj;
    	if(info.length != 2) throw new Exception("Wrong info number: "+info.length);
    	to = key;
    	
    	try
    	{
        	message = (Message) info[0];
        	addresses = (InternetAddress[]) info[1];
        	
        	Transport t = (Transport) account.retrieve("transport");
        	
        	sendTime = now();
            t.sendMessage(message,addresses);
            
            out.println("sending mail to "+to);
            storeMap.put(sendTime,to);
            mailSent();
    	}
    	catch(Exception e)
    	{
    		mailFailed();
    		throw e;
    	}
    }
    
    
	
    public Object provide() throws Exception
	{return to;}
    
    
    
    private SimpleDateFormat yyyyMMdd_HHmmss = new SimpleDateFormat("yyyyMMdd_HHmmss");
    private String now() {return yyyyMMdd_HHmmss.format(new Date());}
    
    
    
    
    private void mailSent()
    {send(this,"mailSent()");}
    
    
    private void mailFailed()
    {send(this,"mailFailed()");}
    
    
    
    
	public Object retrieve(String key) throws Exception
	{
		if(key.equals("storeMap")) return storeMap;
		if(key.equals("message")) return message;
		if(key.equals("addresses")) return addresses;
		if(key.equals("sendTime")) return sendTime;
		
		if(key.equals("keys"))
			return new String[]{"storeMap","message","addresses","sendTime"};
		throw new Exception("Unknown key: "+key);
	}
    
	
	
    
    
//    private void displayMessageHeader(Message message) throws MessagingException
//    {
//    	Enumeration en = message.getAllHeaders();
//    	while(en.hasMoreElements())
//    	{
//    		Header header = (Header) en.nextElement();
//    		String name = header.getName();
//    		String value = header.getValue();
//    		
//    		out.println("mail header: \n" +
//    				"  name="+name+"\n" +
//    			    "  value="+value);
//    	}
//    }
	
}