package gus05.entity.gus.mail.send.mailsender.sendlabel;


import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Timer;
import java.util.TimerTask;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;



public class MailSenderSendLabel implements Entity, Graphic, ActionListener {


    public String getName()				{return "gus.mail.send.mailsender.sendlabel";}
    public String getCreationDate()		{return "2009.05.02";}


    public static final long DELAY = 1600;
    

    private Service mailSender;
    private JLabel label;

    private Timer timer;
    private TimerTask task;
    
    private Icon icon_failed;
    private Icon icon_sent;
    
    
    
    public MailSenderSendLabel() throws Exception
    {
    	mailSender = Outside.service(this,"gus.mail.send.mailsender");
    	
    	icon_failed = (Icon) Outside.resource(this,"icon#MAIL_mailSent_failure");
    	icon_sent = (Icon) Outside.resource(this,"icon#MAIL_mailSent");
    	
    	timer = new Timer();
    	
    	label = new JLabel(" ");
    	label.setFont(label.getFont().deriveFont(Font.ITALIC));
    	mailSender.addActionListener(this);
    }



    public JComponent gui()
    {return label;}
    
    
	public void actionPerformed(ActionEvent e)
	{
		String s = e.getActionCommand();
		if(s.equals("mailSent()")) mailSent();
		else if(s.equals("mailFailed()")) mailFailed();
	}

	
	
	private void mailSent()
	{
		try
		{
			String to = (String) mailSender.provide();
			label.setText(to);
			label.setIcon(icon_sent);
			label.setForeground(Color.BLACK);
			label.setToolTipText("mail sent to "+to);
			startDelay();
		}
		catch(Exception e)
		{Outside.err(this,"displaySending()",e);}
	}
	
	
	
	
	private void mailFailed()
	{
		try
		{
			String to = (String) mailSender.provide();
			label.setText(to);
			label.setIcon(icon_failed);
			label.setForeground(Color.RED);
			label.setToolTipText("failed to send mail to "+to);
			startDelay();
		}
		catch(Exception e)
		{Outside.err(this,"displaySending()",e);}
	}

	
	
	
	
	
	private void startDelay()
    {
    	if(task!=null) task.cancel();
        task = new TimerTask()
        {
            public void run()
            {
            	label.setIcon(null);
            	label.setForeground(Color.LIGHT_GRAY);
            }
        };
        timer.schedule(task,DELAY);
        timer.purge();
    }
}

