package gus05.entity.gus.management.console.log1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;

import java.awt.BorderLayout;
import java.awt.Font;
import java.io.OutputStream;
import java.io.PrintStream;



public class LogConsole1 implements Entity, Graphic {


    public String getName()				{return "gus.management.console.log1";}
    public String getCreationDate()		{return "2007.12.18";}


    private Service outputBuilder;
    private Service appLog;
    
    private JPanel panel;
    private JTextArea logArea;
    


    public LogConsole1() throws Exception
    {
        outputBuilder = Outside.service(this,"gus.io.outputstream.builder");
        appLog = Outside.service(this,"app.out");
        
        logArea = new JTextArea();
        logArea.setEditable(false);
        
        int fontSize = logArea.getFont().getSize();
        logArea.setFont(new Font("Courier New", Font.PLAIN, fontSize));
        
        JLabel titleLabel = new JLabel("log");
        titleLabel.setHorizontalAlignment(SwingConstants.CENTER);
        
        panel = new JPanel(new BorderLayout());
        panel.add(new JScrollPane(logArea),BorderLayout.CENTER);
        panel.add(titleLabel,BorderLayout.NORTH);
        
        OutputStream out = (OutputStream) outputBuilder.transform(logArea);
        appLog.give(new PrintStream(out));
    }



    public JComponent gui()
    {return panel;}


}

