package gus05.entity.gus.management.gui.frame.size2;


import java.awt.Dimension;
import java.awt.DisplayMode;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;



public class FrameSize2 implements Entity {


    public String getName()				{return "gus.management.gui.frame.size2";}
    public String getCreationDate()		{return "2008.11.15";}


    private Service positionsPers;
    private JFrame frame;
    
    private int H;
    private int W;


    public FrameSize2() throws Exception
    {
        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment(); 
        GraphicsDevice device = env.getDefaultScreenDevice();
        DisplayMode displayMode = device.getDisplayMode();
        
        H = displayMode.getHeight();
        W = displayMode.getWidth();
        
        positionsPers = Outside.service(this,"gus.graphic.persistence.positions1");
        frame = (JFrame) Outside.resource(this,"app.gui.frame");
        
        Outside.service(this,"app.supportstart").addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {init();}});
    }
    
    
    
    private void init()
    {
    	try
    	{
    		frame.setSize(new Dimension(W-20,H-50));
            frame.setLocationRelativeTo(null);
            positionsPers.register("mainframe_position",frame);
    	}
    	catch(Exception e)
    	{Outside.err(this,"init()",e);}
    }
}

