package gus05.entity.gus.persistence.fileholder;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;



public class FileHolder implements Entity, Register, ActionListener {


    public String getName()				{return "gus.persistence.fileholder";}
    public String getCreationDate()		{return "2009.02.23";}


    private Service pers;
    private HashMap map;
    

    
    public FileHolder() throws Exception
    {
        pers = Outside.service(this,"app.pers");
        map = new HashMap();
        
        Outside.service(this,"app.supportexit").addActionListener(this);
    }




    public void register(String key, Object obj) throws Exception
    {
        if(!(obj instanceof Give)) throw new Exception("Invalid data type: "+obj.getClass().getName());
        if(!(obj instanceof Provide)) throw new Exception("Invalid data type: "+obj.getClass().getName());
        
        map.put(key,obj);
        String value = (String) pers.retrieve(key);
        if(value!=null)
        {
            Give g = (Give)obj;
            g.give(new File(value));
        }
    }
    
    
    public void actionPerformed(ActionEvent e)
    {save();}
    
    
    
    private void save()
    {
        Iterator it = map.keySet().iterator();
        while(it.hasNext())
        {
            String key = (String) it.next();
            Provide p = (Provide) map.get(key);
            save(key,p);
        }
    }
    
    
    
    
    
    private void save(String key, Provide p)
    {
        try
        {
            File file = (File)p.provide();
            if(file==null)return;
            String path = file.getAbsolutePath();
            pers.register(key,path);
        }
        catch(Exception e)
        {Outside.err(this,"save(String,Provide)",e);}
    }


}

