package gus05.entity.gus.security.askinfo.loginpasswordinit2;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;



class LoginPasswordDialog extends JDialog {

	public static final Color BACKGROUND = Color.WHITE;
	public static final Color FOREGROUND = new Color(0,0,153);
	public static final Color COLORTITLE = new Color(153,204,255);
	public static final int GAP = 8;

	
	private JLabel labelTitle;
	private FormJPanel p_center;
	private JTextField loginField;
	private JPasswordField passwordField;
	private JPasswordField passwordField_confirm;
	private JButton buttonOk;
	private JButton buttonCancel;

	private String login;
	private String password;
	private String password_confirm;
	
	
	
	public LoginPasswordDialog(JFrame parent)
	{
		super(parent,true);
		setUndecorated(true);
		setResizable(false);

		setSize(400, 200);
		setLocationRelativeTo(null);
		
		labelTitle = new JLabel("NOUVEAU COMPTE UTILISATEUR");
		labelTitle.setOpaque(true);
		labelTitle.setHorizontalAlignment(JLabel.CENTER);
		labelTitle.setForeground(FOREGROUND);
		labelTitle.setBackground(COLORTITLE);
		labelTitle.setFont(labelTitle.getFont().deriveFont(Font.BOLD).deriveFont((float)16));
		
		buttonOk = new JButton("OK");
		buttonOk.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{validateLogin();}
		});
		buttonCancel = new JButton("Annuler");
		buttonCancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{cancelLogin();}
		});
		
		
		
		loginField = new JTextField();
		loginField.setFont(loginField.getFont().deriveFont(Font.BOLD));
		loginField.setForeground(FOREGROUND);
		loginField.setCaretColor(FOREGROUND);
		loginField.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				if(!loginField.getText().equals(""))
				passwordField.requestFocusInWindow();
			}
		});
		passwordField = new JPasswordField();
		passwordField.setForeground(FOREGROUND);
		passwordField.setCaretColor(FOREGROUND);
		passwordField.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				if(passwordField.getPassword().length>0)
				passwordField_confirm.requestFocusInWindow();
			}
		});
		passwordField_confirm = new JPasswordField();
		passwordField_confirm.setForeground(FOREGROUND);
		passwordField_confirm.setCaretColor(FOREGROUND);
		passwordField_confirm.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				if(passwordField_confirm.getPassword().length>0)
				validateLogin();
			}
		});
		
		
		p_center = new FormJPanel(20,30,20,30,20,10);
		p_center.setOpaque(false);
		p_center.setForeground(FOREGROUND);

		p_center.addLabel("Entrer le nom d'utilisateur", loginField);
		p_center.addLabel("Entrer le mot de passe", passwordField);
		p_center.addLabel("Confirmer le mot de passe", passwordField_confirm);
		
		
		JPanel p_buttons = new JPanel(new GridLayout(1,2,GAP,GAP));
		p_buttons.setOpaque(false);
		p_buttons.add(buttonOk);
		p_buttons.add(buttonCancel);
		
		JPanel p_bottom = new JPanel();
		p_bottom.setOpaque(false);
		p_bottom.add(p_buttons);
		
		
		
		JPanel contentPane = new JPanel(new BorderLayout());
		contentPane.setBackground(BACKGROUND);
		contentPane.setBorder(BorderFactory.createEmptyBorder(GAP,GAP,GAP,GAP));
		contentPane.add(labelTitle,BorderLayout.NORTH);
		contentPane.add(p_center,BorderLayout.CENTER);
		contentPane.add(p_bottom,BorderLayout.SOUTH);
		
		setContentPane(contentPane);
	}
	
	
	
	public void setLogin(String login)
	{loginField.setText(login);}
	
	
	
	
	
	private void validateLogin()
	{
		login = loginField.getText();
		password = new String(passwordField.getPassword());
		password_confirm = new String(passwordField_confirm.getPassword());
		
		if(!password.equals(password_confirm))
		{
			JOptionPane.showMessageDialog(null,"Mot de passe non confirm.\nResaisissez le mot de passe, s'il vous plait.");
			passwordField.setText("");
			passwordField_confirm.setText("");
			passwordField.requestFocusInWindow();
			return;
		}
		
		loginField.setText("");
		passwordField.setText("");
		passwordField_confirm.setText("");
		dispose();
	}
	
	
	
	
	private void cancelLogin()
	{
		login = null;
		password = null;
		
		loginField.setText("");
		passwordField.setText("");
		passwordField_confirm.setText("");
		dispose();
	}
	
	
	
	
	public String[] getInfos()
	{return new String[]{login,password};}
	
	
	public void setTitle(String title)
	{labelTitle.setText(title);}
}
