package gus05.entity.gus.security.encryption.pbe1.string.decrypt;


import java.security.AlgorithmParameters;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Transform;



public class Pbe1Decrypt implements Entity, Transform {


    public String getName()				{return "gus.security.encryption.pbe1.string.decrypt";}
    public String getCreationDate()		{return "2008.06.24";}

    
    public static final String ALGO = "PBEWithMD5AndDES";
    
    private static final String INFO = "sdf9bfvipq987Vfservc43qq";
    private static final byte[] SALT  = new byte[] {0,0,0,0,0,0,0,0};
    private static final int ITERATION = 3;
 
    
    private Service base64Decoder;
    
    private AlgorithmParameters params;
    private SecretKeyFactory keyFactory;
    private Cipher cipher;
    
    
    
    
    public Pbe1Decrypt() throws Exception
    {
    	base64Decoder = Outside.service(this,"gus.tobytearray.base64tobyte");
    	
    	params = AlgorithmParameters.getInstance(ALGO);
		params.init(new PBEParameterSpec(SALT,ITERATION));
		keyFactory = SecretKeyFactory.getInstance(ALGO);
    	cipher = Cipher.getInstance(ALGO);
    }



    public Object transform(Object obj) throws Exception
    {
		PBEKeySpec keySpec = new PBEKeySpec(INFO.toCharArray());
		SecretKey key = keyFactory.generateSecret(keySpec);

		String ciphertext = (String) obj;
		byte[] cipherbytes = decode(ciphertext);
		
		cipher.init(Cipher.DECRYPT_MODE, key, params);
		byte[] textbytes = cipher.doFinal(cipherbytes);
		return new String(textbytes);
    }


    
    private byte[] decode(String s) throws Exception
    {return (byte[]) base64Decoder.transform(s);}
}

