package gus05.entity.gus.security.encryption.pbe1.stringcol.decrypt;


import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Transform;



public class Pbe1DecryptStringCollection implements Entity, Transform {


    public String getName()				{return "gus.security.encryption.pbe1.stringcol.decrypt";}
    public String getCreationDate()		{return "2008.06.24";}


    private Service decrypt;

    public Pbe1DecryptStringCollection() throws Exception
    {decrypt = Outside.service(this,"gus.security.encryption.pbe1.string.decrypt");}

    
    private String de(String input) throws Exception
    {return (String) decrypt.transform(input);}
    
    
    
    public Object transform(Object obj) throws Exception
    {
    	if(obj instanceof String) return de((String)obj);
    	if(obj instanceof Map) return decrypt_map((Map)obj);
    	if(obj instanceof List) return decrypt_list((List)obj);
    	if(obj instanceof Set) return decrypt_set((Set)obj);
    	
    	throw new Exception("invalid input data type: "+obj.getClass().getName());
    }
    
    
    
    
    
    
    private Map decrypt_map(Map map) throws Exception
    {
    	Properties map1 = new Properties();
		Iterator it = map.keySet().iterator();
		while(it.hasNext())
		{
			String key = (String) it.next();
			String value = (String) map.get(key);
			map1.setProperty(de(key),de(value));
		}
		return map1;
    }
    
    
    
    
    private List decrypt_list(List list) throws Exception
    {
    	ArrayList list1 = new ArrayList();
		for(int i=0;i<list.size();i++)
		{
			String value = (String) list.get(i);
			list1.add(de(value));
		}
		return list1;
    }
    
    
    
    
    private Set decrypt_set(Set set) throws Exception
    {
    	HashSet set1 = new HashSet();
		Iterator it = set.iterator();
		while(it.hasNext())
		{
			String value = (String) it.next();
			set1.add(de(value));
		}
		return set1;
    }
}

