package gus05.entity.gus.watching.online.label;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;
import gus05.framework.resources.IconProvider;

import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;



public class OnlineLabel implements Entity, Graphic, ActionListener {


    public String getName()				{return "gus.watching.online.label";}
    public String getCreationDate()		{return "2007.10.19";}


    private Service onlineWatching;
    private IconProvider iconProvider;

    private JLabel label;
    private Icon icon_online;
    private Icon icon_offline;


    public OnlineLabel() throws Exception
    {
        onlineWatching = Outside.service(this,"gus.watching.online");
        iconProvider = (IconProvider) Outside.resource(this,"app.gui.icons");
        
        icon_online = iconProvider.getIcon("WEB_online");
        icon_offline = iconProvider.getIcon("WEB_offline");
        
        label = new JLabel();
        updateLabel();
        
        onlineWatching.addActionListener(this);
    }



    public JComponent gui()
    {return label;}



    public void actionPerformed(ActionEvent e)
    {updateLabel();}
    
    
    
    private void updateLabel()
    {
        try
        {
            boolean isOnline = onlineWatching.filter(null);
            if(isOnline)
            {
                label.setIcon(icon_online);
                label.setText("online");
                label.setForeground(Color.BLUE);
            }
            else
            {
                label.setIcon(icon_offline);
                label.setText("offline");
                label.setForeground(Color.GRAY);
            }
        }
        catch(Exception e)
        {Outside.err(this,"updateLabel()",e);}
    }


}

