package gus05.entity.gus.website.restrict.getreleaseprop;


import java.io.FileNotFoundException;
import java.net.URL;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;



public class GetReleaseProp implements Entity, Retrieve, Register {


    public String getName()				{return "gus.website.restrict.getreleaseprop";}
    public String getCreationDate()		{return "2009.01.29";}


    
    private Service urlToPropAuth;
    private Service getReleaseUrl;
    
    private String userName;
    private String password;
    

    public GetReleaseProp() throws Exception
    {
    	urlToPropAuth = Outside.service(this,"gus.web.download.urltoproperties.auth1");
    	getReleaseUrl = Outside.service(this,"gus.website.restrict.getreleaseurl");
    }



    public Object retrieve(String key) throws Exception
    {
    	URL releaseURL = (URL) getReleaseUrl.retrieve(key);
    	
    	try
    	{
    		urlToPropAuth.register("login",userName);
        	urlToPropAuth.register("password",password);
        	return (Properties) urlToPropAuth.transform(releaseURL);
    	}
    	catch(Exception e)
    	{
    		if(e instanceof FileNotFoundException) return null;
    		throw e;
    	}
    }
    
    
    
    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("userName")) {userName = (String) obj;return;}
    	if(key.equals("password")) {password = (String) obj;return;}
        
        throw new Exception("Unknown key: "+key);
    }
    
}

