package gus05.manager.gus.endorf.layer2.datasupport;

import java.awt.event.ActionListener;
import java.util.List;

import gus05.framework.features.Support;
import gus05.framework.tools.DefaultSupport;

import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.PlainDocument;

public class SupportDocument extends PlainDocument implements Support {

    
    private DefaultSupport support;
    private String name;
    
    public String toString()
    {return name;}
    
    
    
    
    public SupportDocument(String name) throws Exception
    {this(name,"");}
    
    
    
    public SupportDocument(String name, String text) throws Exception
    {
        this.name = name;
        support = new DefaultSupport();
        insertString(0, text, null);
        
        addDocumentListener(new DocumentListener()
        {
            public void changedUpdate(DocumentEvent e) {}
            public void insertUpdate(DocumentEvent e) {textModified();}
            public void removeUpdate(DocumentEvent e) {textModified();}
        });
    }
    
    
    
    private void textModified()
    {support.send(this,"textModified()");}
    
    
    public void addActionListener(ActionListener listener)
    {support.addActionListener(listener);}
    
    public void removeActionListener(ActionListener listener)
    {support.removeActionListener(listener);}
    
    public List listeners()
    {return support.listeners();}

}
