package gus05.manager.gus.endorf.layer4.internals1;

import javax.swing.ImageIcon;
import javax.swing.JFrame;

import gus05.framework.features.Give;
import gus05.manager.gus.endorf.layer4.system2.System2;




public class AppFrameCustomizer implements Give {

    
    
    private ImageIcon appIcon;
    
    
    
    
    public AppFrameCustomizer()
    {
        if(!System2.hasProperty(System2.PROPKEY_APPICON))return;
        
        String iconKey = System2.getProperty(System2.PROPKEY_APPICON);
        appIcon = (ImageIcon)System2.iconMap.get(iconKey);
        System2.putInternal(System2.INTERNAL_ICON_APPICON,appIcon);
    }
    
    
    
    
    
    public void give(Object obj) throws Exception
    {
        JFrame frame = (JFrame) obj;

        // init frame icon
        initIcon(frame);
        // init frame title
        initTitle(frame);
        // init frame size
        initSize(frame);
        
        frame.setLocationRelativeTo(null);
        if(visibleOnStart()) frame.setVisible(true);
    }
    
    
    
    
    
    
    
    
    private void initIcon(JFrame frame)
    {
        if(appIcon!=null)
        frame.setIconImage(appIcon.getImage());
    }
    
    
    
    
    private void initTitle(JFrame frame)
    {
        StringBuffer b = new StringBuffer();
        if(System2.hasProperty(System2.PROPKEY_APPTITLE))
        {
            String title = System2.getProperty(System2.PROPKEY_APPTITLE);
            b.append(title);
        }
        if(System2.hasProperty(System2.PROPKEY_APPVERSION))
        {
            String version = System2.getProperty(System2.PROPKEY_APPVERSION);
            b.append(" "+version);
        }
        if(System2.hasProperty(System2.PROPKEY_APPUSER))
        {
            String user = System2.getProperty(System2.PROPKEY_APPUSER);
            b.append(" - "+user);
        }
        frame.setTitle(b.toString());
    }
    
    
    
    private void initSize(JFrame frame)
    {
        if(!System2.hasProperty(System2.PROPKEY_APPSIZE))
            initSize_default(frame);
        else initSize(frame,System2.getProperty(System2.PROPKEY_APPSIZE)); 
    }
    
    
    
    
    private boolean visibleOnStart()
    {return System2.booleanProperty_true(System2.PROPKEY_APPVISIBLEONSTART);}
    
    
    
    
    private void initSize(JFrame frame, String info)
    {
        if(info.startsWith("*"))
        {
            frame.setResizable(false);
            info = info.substring(1);
        }
        if(info.equals("pack")) frame.pack();
        else
        {
            String[] n = info.split(" ");
            int X = Integer.parseInt(n[0]);
            int Y = Integer.parseInt(n[1]);
            frame.setSize(X,Y);
        }
    }
    
    
    
    
    private void initSize_default(JFrame frame)
    {
        frame.setSize(900,600);
    }

}
