
package gus05.manager.gus.endorf.layer4.system2;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.manager.gus.endorf.layer2.datasupport.SupportMap;





public class EntityGenerator {

    
    private SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd");
    
    private Map entitiesMap;
    private Map buildTimeMap;
    
    public Map getEntitiesMap()
    {return entitiesMap;}
    
    public Map getBuildTimeMap()
    {return buildTimeMap;}
    
    
    
    
    public EntityGenerator()
    {
    	entitiesMap = new SupportMap("entityUniqueMap");
    	buildTimeMap = new SupportMap("buildTimeMap");
    }
    
    
    public int number = 0;
    
    
    
    
    
    
    public Map getInfo(String name) throws Exception
    {
        if(!System2.infoMap.containsKey(name))
            throw new Exception("info not found for name "+name);
        return (Map)System2.infoMap.get(name);
    }
    
    
    
    public String multiplicity(String name) throws Exception
    {
        Map m = getInfo(name);
        return (String) m.get(System2.ENTITYINFO_MULTIPLICITY);
    }
    
    
    
    
    
    
    
    public Entity newEntity(Object source, String name) throws Exception
    {
        String sourceID = System2.sourceName(source);
        if(printCreation())
            System2.appOut.println("NEW-"+name+" (src="+sourceID+")");
        return CREATE_ENTITY(name,sourceID);
    }
    
    
    
    
    
    
    
    public Entity newEntity(Object source, String name, String key) throws Exception
    {
        String sourceID = System2.sourceName(source);
        int c = 0;
        while(entitiesMap.containsKey(key+"_"+c)) c++;
        key = key+"_"+c;
        
        if(printCreation())
            System2.appOut.println("NEW-"+name+" (key="+key+") (src="+sourceID+")");
        
        entitiesMap.put(key,CREATE_ENTITY(name,sourceID));
        return (Entity)entitiesMap.get(key);
    }
    
    
    
    
    
    
    
    public Entity uniqueEntity(Object source, String name) throws Exception
    {
        String sourceID = System2.sourceName(source);
        if(printCreation())
        {
            if(!entitiesMap.containsKey(name))
                System2.appOut.println("0-UNIQUE-"+name+" (src="+sourceID+")");
            else System2.appOut.println("UNIQUE-"+name+" (src="+sourceID+")");           
        }
        
        if(!entitiesMap.containsKey(name))
            entitiesMap.put(name,CREATE_ENTITY(name,sourceID));
        return (Entity)entitiesMap.get(name);
    }
    
    
    
    
    
    
    
    
    public Entity uniqueEntity(Object source, String name, String key) throws Exception
    {
        String sourceID = System2.sourceName(source);
        if(printCreation())
        {
            if(!entitiesMap.containsKey(key))
                System2.appOut.println("0-UNIQUE-"+name+" (key="+key+") (src="+sourceID+")");
            else System2.appOut.println("UNIQUE-"+name+" (key="+key+") (src="+sourceID+")");
        }
        
        if(!entitiesMap.containsKey(key))
            entitiesMap.put(key,CREATE_ENTITY(name,sourceID));
        return (Entity)entitiesMap.get(key);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private Entity CREATE_ENTITY(String name, String sourceID) throws Exception
    {
        try
        {
            // creation
            if(!System2.isEntity(name)) throw new Exception("Unknown entity: "+name);
            if(sourceID.equals(name)) throw new Exception("Entity is calling itself: "+name);
            
            Class c = System2.getEntityClass(name);
            
            long t1 = System.nanoTime();
            Entity entity = (Entity)c.newInstance();
            long t2 = System.nanoTime();
            
            checkEntityValidity(name,entity);
            newEntityCreated(entity,t2-t1);
            number++;
            return entity;
        }
        catch(Exception e)
        {
            System2.printMessage(this,"createEntity(String)","entity failed: "+name);
            throw e;
        }
    }


    
    
    
    
    
    
    private void newEntityCreated(Entity entity, long delay)
    {
        String name = entity.getName();
        String creationDate = entity.getCreationDate();
        buildTimeMap.put(name,new Long(delay));
        
        // register entity creation date
        Map dateMap = (Map)System2.getInternal(System2.INTERNAL_MAP_DATEENTITY);
        if(dateMap!=null) dateMap.put(name,creationDate);
        
        // register entity used date
        Map usedMap = (Map)System2.getInternal(System2.INTERNAL_MAP_USEDDATEENTITY);
        if(usedMap!=null) usedMap.put(name,System2.now());
        
        // update the entity number
        Map numberMap = (Map)System2.getInternal(System2.INTERNAL_MAP_NUMBERENTITY);
        if(numberMap!=null)
        {
            Integer n = numberMap.containsKey(name)?(Integer)numberMap.get(name):new Integer(0);
            n = new Integer(n.intValue()+1);
            numberMap.put(name,n);
        }
    }
    
    
    
    
    
    private void checkEntityValidity(String name, Entity entity) throws Exception
    {
        String name0 = entity.getName();
        String date0 = entity.getCreationDate();
        
        if(!name0.equals(name))
            throw new Exception("entity name conflict o:"+name+" i:"+name0);
        
        String date = (String) getInfo(name).get(System2.ENTITYINFO_CREATIONDATE);
        if(!date.equals("?"))if(!date0.equals(date))
            throw new Exception("entity creation date conflict o:"+date+" i:"+date0);
        
        Date d = sdf.parse(date0);
        if(d.after(System2.appStartDate))
        System2.printWarning(this,"checkEntityValidity(String,Entity)","futurist entity creation date:"+date0);
    }
    
    
    
    
    private boolean printCreation()
    {return System2.booleanProperty_false(System2.PROPKEY_PRINTENTITYCREATIONS);}
    
}
